package com.lpsfr.lib.utils;

import android.os.Handler;
import android.os.HandlerThread;

import androidx.annotation.NonNull;

public class Async {
    private static HandlerThread handler_thread = null;
    private final Handler handler;

    public Async(@NonNull String name) {
        if (null == handler_thread) {
            handler_thread = new HandlerThread(name);
            handler_thread.start();
        }

        handler = new Handler(handler_thread.getLooper());
    }

    public void run(Runnable runnable) {
        handler.post(runnable);
    }
}