export declare type Availabilities = "SUPPORTED_APK_TOO_OLD" | "SUPPORTED_INSTALLED" | "SUPPORTED_NOT_INSTALLED" | "UNKNOWN_CHECKING" | "UNKNOWN_ERROR" | "UNKNOWN_TIMED_OUT" | "UNSUPPORTED_DEVICE_NOT_CAPABLE";
export interface ArCoreAvailability {
    name?: Availabilities;
    isSupported?: boolean;
    isTransient?: boolean;
    isUnknown?: boolean;
    isUnsupported?: boolean;
}
export default class ARCore {
    constructor();
    checkARCoreAvailability(): Promise<ArCoreAvailability>;
    isRunningOnEmulator: () => Promise<any>;
    isCompatible: () => Promise<boolean>;
}
