import { RawType } from "./Types";
export var AlimentationType;
(function (AlimentationType) {
    AlimentationType["NO_BATTERY"] = "NO_BATTERY";
    AlimentationType["BATTERIES"] = "BATTERIES";
    AlimentationType["PHOTOVOLTAIC"] = "PHOTOVOLTAIC";
})(AlimentationType || (AlimentationType = {}));
export var transformFrom = function (value) {
    if (!value)
        return "NO_BATTERY";
    switch (value) {
        case AlimentationType.PHOTOVOLTAIC: return "PHOTOVOLTAIC";
        case AlimentationType.BATTERIES: return "BATTERIES";
        default: return "NO_BATTERY";
    }
};
export var transformInto = function (value) {
    if (!value)
        return AlimentationType.NO_BATTERY;
    if (value === "BATTERIES")
        return AlimentationType.BATTERIES;
    if (value === "PHOTOVOLTAIC")
        return AlimentationType.PHOTOVOLTAIC;
    return AlimentationType.NO_BATTERY;
};
export var TypeAlimentationType = {
    type: RawType.Text,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=AlimentationType.js.map