import { RawType } from "./Types";
export var Cd;
(function (Cd) {
    Cd[Cd["HIGHER"] = 0] = "HIGHER";
    Cd[Cd["TINIER"] = 1] = "TINIER";
    Cd[Cd["ISOLATED"] = 2] = "ISOLATED";
    Cd[Cd["HILL"] = 3] = "HILL";
})(Cd || (Cd = {}));
var CdValues = [];
CdValues[Cd.HIGHER] = 0.25;
CdValues[Cd.TINIER] = 0.5;
CdValues[Cd.ISOLATED] = 1;
CdValues[Cd.HILL] = 2;
export var getCD = function (cd) { return CdValues[cd] || CdValues[Cd.HILL]; };
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case Cd.TINIER: return 1;
        case Cd.ISOLATED: return 2;
        case Cd.HILL: return 3;
        //case Cd.HIGHER: return 0;
        default: return Cd.HIGHER;
    }
};
var transformInto = function (value) {
    if (!value)
        return Cd.HIGHER;
    value = parseInt(value);
    switch (value) {
        case 3: return Cd.HILL;
        case 2: return Cd.ISOLATED;
        case 1: return Cd.TINIER;
        default: return Cd.HIGHER;
    }
};
export var TypeCd = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=Cd.js.map