import { RawType } from "./Types";
export var Danger;
(function (Danger) {
    Danger[Danger["NO_DANGER"] = 0] = "NO_DANGER";
    Danger[Danger["LOW_PANIK"] = 1] = "LOW_PANIK";
    Danger[Danger["MEDIUM_PANIK"] = 2] = "MEDIUM_PANIK";
    Danger[Danger["EVACUATION_DIFFICULT"] = 3] = "EVACUATION_DIFFICULT";
    Danger[Danger["HIGH_PANIK_LEVEL"] = 4] = "HIGH_PANIK_LEVEL";
})(Danger || (Danger = {}));
var DangerValues = [];
DangerValues[Danger.NO_DANGER] = 1;
DangerValues[Danger.LOW_PANIK] = 2;
DangerValues[Danger.MEDIUM_PANIK] = 5;
DangerValues[Danger.EVACUATION_DIFFICULT] = 5.0;
DangerValues[Danger.HIGH_PANIK_LEVEL] = 10;
export var getDanger = function (danger) { return DangerValues[danger] || DangerValues[Danger.NO_DANGER]; };
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case Danger.HIGH_PANIK_LEVEL: return 4;
        case Danger.EVACUATION_DIFFICULT: return 3;
        case Danger.MEDIUM_PANIK: return 2;
        case Danger.LOW_PANIK: return 1;
        default: return 0;
    }
};
var transformInto = function (value) {
    if (!value)
        return Danger.NO_DANGER;
    value = parseInt(value);
    switch (value) {
        case 4: return Danger.HIGH_PANIK_LEVEL;
        case 3: return Danger.EVACUATION_DIFFICULT;
        case 2: return Danger.MEDIUM_PANIK;
        case 1: return Danger.LOW_PANIK;
        default: return Danger.NO_DANGER;
    }
};
export var TypeDanger = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=Danger.js.map