import { RawType } from "./Types";
export var DisplayType;
(function (DisplayType) {
    DisplayType[DisplayType["MECHANICAL"] = 0] = "MECHANICAL";
    DisplayType[DisplayType["EPAPER"] = 1] = "EPAPER";
    DisplayType[DisplayType["DIGITAL"] = 2] = "DIGITAL";
    DisplayType[DisplayType["LED"] = 3] = "LED";
})(DisplayType || (DisplayType = {}));
var transformFromEnum = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case DisplayType.LED: return 3;
        case DisplayType.DIGITAL: return 2;
        case DisplayType.EPAPER: return 1;
        default: return 0;
    }
};
var transformIntoEnum = function (value) {
    if (!value)
        return DisplayType.MECHANICAL;
    value = parseInt(value);
    switch (value) {
        case 3: return DisplayType.LED;
        case 2: return DisplayType.DIGITAL;
        case 1: return DisplayType.EPAPER;
        default: return DisplayType.MECHANICAL;
    }
};
export var TypeDisplayType = {
    type: RawType.Integer,
    transformIntoTable: transformFromEnum,
    transformFromTable: transformIntoEnum
};
//# sourceMappingURL=DisplayType.js.map