import { AssetType } from "./AssetType";
export var transformIntoDate = function (value) {
    if (!value)
        return undefined;
    if (value instanceof Date)
        return value;
    //TODO check for string ?
    return new Date(value);
};
export var transformIntoReal = function (value) {
    if (!value)
        return undefined;
    if (value instanceof Date)
        return value.getTime();
    //TODO check for string ?
    var numb = parseFloat(value);
    if (isNaN(numb))
        return undefined;
    return numb;
};
export var transformIntoNumber = function (value) {
    if (!value)
        return undefined;
    if (value instanceof Date) {
        return value.getTime();
    }
    //TODO check for string ?
    var numb = parseInt(value);
    if (isNaN(numb))
        return undefined;
    return numb;
};
export var transformIntoBoolean = function (value) {
    if (!!value && typeof value == "string" && value.toLowerCase() == "false") {
        return false;
    }
    return !!value;
};
export var transformIntoText = function (value) {
    if (null === value || undefined === value)
        return undefined;
    return "" + value;
};
export var transformIntoTextKey = function (value) {
    var str = transformIntoText(value);
    if (null === str || undefined === str)
        return undefined;
    return str.replace(/[^0-9a-zA-Z\-\_]/g, '').toLowerCase();
};
export var transformFromAssetType = function (value) {
    if (!value)
        return "photo";
    switch (value) {
        case AssetType.LINK: return "link";
        case AssetType.PHOTO:
        default: return "photo";
    }
};
export var transformIntoAssetType = function (value) {
    if (!value)
        return AssetType.PHOTO;
    switch (value) {
        case "link": return AssetType.LINK;
        default: return AssetType.PHOTO;
    }
};
//# sourceMappingURL=FieldHelper.js.map