import { RawType } from "./Types";
export var FixationSupportType;
(function (FixationSupportType) {
    FixationSupportType["ROOF"] = "ROOF";
    FixationSupportType["WALL"] = "WALL";
    FixationSupportType["TERRACE"] = "TERRACE";
    FixationSupportType["GROUND"] = "GROUND";
    FixationSupportType["CHIMNEY"] = "CHIMNEY";
    FixationSupportType["OTHER"] = "OTHER";
})(FixationSupportType || (FixationSupportType = {}));
var transformFrom = function (value) {
    if (!value)
        return "OTHER";
    switch (value) {
        case FixationSupportType.ROOF: return "ROOF";
        case FixationSupportType.WALL: return "WALL";
        case FixationSupportType.TERRACE: return "TERRACE";
        case FixationSupportType.GROUND: return "GROUND";
        case FixationSupportType.CHIMNEY: return "CHIMNEY";
        case FixationSupportType.OTHER:
        default:
            return "OTHER";
    }
};
var transformInto = function (value) {
    if (!value)
        return FixationSupportType.OTHER;
    switch (value) {
        case "ROOF": return FixationSupportType.ROOF;
        case "WALL": return FixationSupportType.WALL;
        case "CHIMNEY": return FixationSupportType.CHIMNEY;
        case "TERRACE": return FixationSupportType.TERRACE;
        case "GROUND": return FixationSupportType.GROUND;
        case "OTHER":
        default:
            return FixationSupportType.OTHER;
    }
};
export var TypeFixationSupportType = {
    type: RawType.Text,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=FixationSupportType.js.map