import { RawType } from "./Types";
export var InstallationState;
(function (InstallationState) {
    InstallationState[InstallationState["INITIAL_DECLARATION"] = 0] = "INITIAL_DECLARATION";
    InstallationState[InstallationState["WAITING_FOR_VERIFICATION"] = 1] = "WAITING_FOR_VERIFICATION";
    InstallationState[InstallationState["VERIFIED"] = 2] = "VERIFIED";
    InstallationState[InstallationState["PENDING_VERIFICATION"] = 3] = "PENDING_VERIFICATION";
})(InstallationState || (InstallationState = {}));
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case InstallationState.PENDING_VERIFICATION: return 3;
        case InstallationState.VERIFIED: return 2;
        case InstallationState.WAITING_FOR_VERIFICATION: return 1;
        default: return 0; //INITIAL_DECLARATION
    }
};
var transformInto = function (value) {
    if (!value)
        return InstallationState.INITIAL_DECLARATION;
    value = parseInt(value);
    switch (value) {
        case 3: return InstallationState.PENDING_VERIFICATION;
        case 2: return InstallationState.VERIFIED;
        case 1: return InstallationState.WAITING_FOR_VERIFICATION;
        default: return InstallationState.INITIAL_DECLARATION;
    }
};
export var TypeInstallationStateType = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=InstallationState.js.map