import { RawType } from "./Types";
export var MaintenanceInterval;
(function (MaintenanceInterval) {
    MaintenanceInterval["MONTHS_6"] = "MONTHS_6";
    MaintenanceInterval["YEAR_1"] = "YEAR_1";
    MaintenanceInterval["YEAR_2"] = "YEAR_2";
})(MaintenanceInterval || (MaintenanceInterval = {}));
export var transformFromMaintenanceInterval = function (value) {
    if (!value)
        return "COPPER";
    switch (value) {
        case MaintenanceInterval.YEAR_2: return "YEAR_2";
        case MaintenanceInterval.MONTHS_6: return "MONTHS_6";
        default: return "YEAR_1";
    }
};
export var transformIntoMaintenanceInterval = function (value) {
    if (!value)
        return MaintenanceInterval.YEAR_1;
    if (value === "MONTHS_6")
        return MaintenanceInterval.MONTHS_6;
    if (value === "YEAR_2")
        return MaintenanceInterval.YEAR_2;
    return MaintenanceInterval.YEAR_1;
};
export var TypeMaintenanceInterval = {
    type: RawType.Text,
    transformIntoTable: transformFromMaintenanceInterval,
    transformFromTable: transformIntoMaintenanceInterval
};
//# sourceMappingURL=MaintenanceInterval.js.map