import { RawType } from "./Types";
export var MaterialLightningRodType;
(function (MaterialLightningRodType) {
    MaterialLightningRodType["COPPER"] = "COPPER";
    MaterialLightningRodType["STEEL"] = "STEEL";
    MaterialLightningRodType["STEEL_INOX"] = "STEEL_INOX";
    MaterialLightningRodType["ALUMINIUM"] = "ALUMINIUM";
    MaterialLightningRodType["OTHER"] = "OTHER";
})(MaterialLightningRodType || (MaterialLightningRodType = {}));
export var transformFromMaterialLightningRodType = function (value) {
    if (!value)
        return "OTHER";
    switch (value) {
        case MaterialLightningRodType.COPPER: return "COPPER";
        case MaterialLightningRodType.STEEL: return "STEEL";
        case MaterialLightningRodType.STEEL_INOX: return "STEEL_INOX";
        case MaterialLightningRodType.ALUMINIUM: return "ALUMINIUM";
        default:
            return "OTHER";
    }
};
export var transformIntoMaterialLightningRodType = function (value) {
    if (!value)
        return MaterialLightningRodType.OTHER;
    switch (value) {
        case "COPPER": return MaterialLightningRodType.COPPER;
        case "STEEL": return MaterialLightningRodType.STEEL;
        case "STEEL_INOX": return MaterialLightningRodType.STEEL_INOX;
        case "ALUMINIUM": return MaterialLightningRodType.ALUMINIUM;
        default:
            return MaterialLightningRodType.OTHER;
    }
};
export var TypeMaterialLightningRodType = {
    type: RawType.Text,
    transformIntoTable: transformFromMaterialLightningRodType,
    transformFromTable: transformIntoMaterialLightningRodType
};
//# sourceMappingURL=MaterialLightningRodType.js.map