import { RawType } from "./Types";
export var MaterialSupportType;
(function (MaterialSupportType) {
    MaterialSupportType["STEEL_INOX"] = "STEEL_INOX";
    MaterialSupportType["STEEL_GALVANIZED"] = "STEEL_GALVANIZED";
    MaterialSupportType["ALUMINIUM"] = "ALUMINIUM";
    MaterialSupportType["FIBER_GLASS"] = "FIBER_GLASS";
    MaterialSupportType["STEEL_PAINTED"] = "STEEL_PAINTED";
    MaterialSupportType["OTHER"] = "OTHER";
})(MaterialSupportType || (MaterialSupportType = {}));
var transformFrom = function (value) {
    if (!value)
        return "OTHER";
    switch (value) {
        case MaterialSupportType.FIBER_GLASS: return "FIBER_GLASS";
        case MaterialSupportType.STEEL_INOX: return "STEEL_INOX";
        case MaterialSupportType.STEEL_GALVANIZED: return "STEEL_GALVANIZED";
        case MaterialSupportType.STEEL_PAINTED: return "STEEL_PAINTED";
        default:
            return "OTHER";
    }
};
var transformInto = function (value) {
    if (!value)
        return MaterialSupportType.OTHER;
    switch (value) {
        case "FIBER_GLASS": return MaterialSupportType.FIBER_GLASS;
        case "STEEL_INOX": return MaterialSupportType.STEEL_INOX;
        case "STEEL_GALVANIZED": return MaterialSupportType.STEEL_GALVANIZED;
        case "STEEL_PAINTED": return MaterialSupportType.STEEL_PAINTED;
        case "ALUMINIUM":
        default:
            return MaterialSupportType.OTHER;
    }
};
export var TypeMaterialSupportType = {
    type: RawType.Text,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=MaterialSupportType.js.map