import { RawType } from "./Types";
export var Occupation;
(function (Occupation) {
    Occupation[Occupation["STANDARD"] = 0] = "STANDARD";
    Occupation[Occupation["NO_OCCUPATION"] = 1] = "NO_OCCUPATION";
})(Occupation || (Occupation = {}));
var OccupationValues = [];
OccupationValues[Occupation.STANDARD] = 0.1;
OccupationValues[Occupation.NO_OCCUPATION] = 0.01;
export var getOccupation = function (occupation) { return OccupationValues[occupation] || OccupationValues[Occupation.NO_OCCUPATION]; };
var transformFrom = function (value) {
    if (!value)
        return 0;
    if (value == Occupation.NO_OCCUPATION)
        return 1;
    return 0;
};
var transformInto = function (value) {
    if (!value)
        return Occupation.STANDARD;
    value = parseInt(value);
    if (value == 1)
        return Occupation.NO_OCCUPATION;
    return Occupation.STANDARD;
};
export var TypeOccupation = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=Occupation.js.map