var ProjectRelatedTableHelper = /** @class */ (function () {
    function ProjectRelatedTableHelper() {
    }
    ProjectRelatedTableHelper.prototype.createTableCreationQuery = function (descriptor) {
        return descriptor.toString();
    };
    ProjectRelatedTableHelper.prototype.createIndexes = function (descriptor) {
        var id_or_parent = descriptor.columns.filter(function (c) { return !!c.isPrimary(); });
        return id_or_parent.map(function (c) { return "CREATE INDEX " + c.name() + descriptor.name + " ON \"" + descriptor.name + "\" (" + c.name() + ");"; });
    };
    ProjectRelatedTableHelper.prototype.createSelectionQuery = function (descriptor, selector_key) {
        var name = descriptor.name, columns = descriptor.columns;
        var formatted_keys = columns.map(function (c) { return c.name(); }).join(",");
        if (selector_key)
            return "SELECT " + formatted_keys + " FROM " + name + " WHERE " + selector_key + " = ?";
        return "SELECT " + formatted_keys + " FROM " + name;
    };
    ProjectRelatedTableHelper.prototype.createDeleteQuery = function (descriptor, selector_key) {
        var name = descriptor.name;
        return "DELETE FROM " + name + " WHERE " + selector_key + " = ?";
    };
    ProjectRelatedTableHelper.prototype.createCreateQuery = function (descriptor) {
        var filtered = descriptor.columns.filter(function (k) { return !k.isPrimary(); }).map(function (c) { return c.name(); });
        var names = filtered.map(function (k) { return "`" + k + "`"; }).join(",");
        var marks = filtered.map(function (k) { return "?"; }).join(",");
        return "INSERT INTO " + descriptor.name + " (" + names + ") VALUES (" + marks + ");";
    };
    ProjectRelatedTableHelper.prototype.createUpdateQuery = function (descriptor) {
        var name = descriptor.name, columns = descriptor.columns;
        var cols = columns.filter(function (k) { return !k.isPrimary(); }).map(function (c) { return c.name(); }) //remove the id key
            .map(function (k) { return "'" + k + "'=?"; }) //transform every to "  'some_column'=?   ";
            .join(", "); //and then join every with the , separator
        return "UPDATE " + name + " SET " + cols + " WHERE id = ?";
    };
    ProjectRelatedTableHelper.prototype.drop = function (descriptor) {
        var name = descriptor.name;
        return "DROP TABLE " + name + ";";
    };
    return ProjectRelatedTableHelper;
}());
export default ProjectRelatedTableHelper;
//# sourceMappingURL=ProjectRelatedTableHelper.js.map