import { RawType } from "./Types";
export var ProtectionLevel;
(function (ProtectionLevel) {
    ProtectionLevel[ProtectionLevel["UNKNOWN"] = 0] = "UNKNOWN";
    ProtectionLevel[ProtectionLevel["LEVEL_1"] = 1] = "LEVEL_1";
    ProtectionLevel[ProtectionLevel["LEVEL_2"] = 2] = "LEVEL_2";
    ProtectionLevel[ProtectionLevel["LEVEL_3"] = 3] = "LEVEL_3";
    ProtectionLevel[ProtectionLevel["LEVEL_4"] = 4] = "LEVEL_4";
    ProtectionLevel[ProtectionLevel["LEVEL_1_PLUS"] = 5] = "LEVEL_1_PLUS";
    ProtectionLevel[ProtectionLevel["LEVEL_1_PLUS_PLUS"] = 6] = "LEVEL_1_PLUS_PLUS";
})(ProtectionLevel || (ProtectionLevel = {}));
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case ProtectionLevel.LEVEL_1_PLUS_PLUS: return 6;
        case ProtectionLevel.LEVEL_1_PLUS: return 5;
        case ProtectionLevel.LEVEL_4: return 4;
        case ProtectionLevel.LEVEL_3: return 3;
        case ProtectionLevel.LEVEL_2: return 2;
        case ProtectionLevel.LEVEL_1: return 1;
        default: return 0;
    }
};
var transformInto = function (value) {
    if (!value)
        return ProtectionLevel.UNKNOWN;
    value = parseInt(value);
    switch (value) {
        case 6: return ProtectionLevel.LEVEL_1_PLUS_PLUS;
        case 5: return ProtectionLevel.LEVEL_1_PLUS;
        case 4: return ProtectionLevel.LEVEL_4;
        case 3: return ProtectionLevel.LEVEL_3;
        case 2: return ProtectionLevel.LEVEL_2;
        case 1: return ProtectionLevel.LEVEL_1;
        default: return ProtectionLevel.UNKNOWN;
    }
};
export var TypeProtectionLevel = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=ProtectionLevel.js.map