import { RawType } from "./Types";
export var RiskFire;
(function (RiskFire) {
    RiskFire[RiskFire["LOW"] = 0] = "LOW";
    RiskFire[RiskFire["STANDARD"] = 1] = "STANDARD";
    RiskFire[RiskFire["HIGH"] = 2] = "HIGH";
})(RiskFire || (RiskFire = {}));
var RiskFireValues = [];
RiskFireValues[RiskFire.LOW] = 0.001;
RiskFireValues[RiskFire.STANDARD] = 0.01;
RiskFireValues[RiskFire.HIGH] = 0.1;
export var getRiskFire = function (risk) { return RiskFireValues[risk] || RiskFireValues[RiskFire.LOW]; };
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case RiskFire.HIGH: return 2;
        case RiskFire.STANDARD: return 1;
        default: return 0;
    }
};
var transformInto = function (value) {
    if (!value)
        return RiskFire.LOW;
    value = parseInt(value);
    switch (value) {
        case 2: return RiskFire.HIGH;
        case 1: return RiskFire.STANDARD;
        default: return RiskFire.LOW;
    }
};
export var TypeRiskFire = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=RiskFire.js.map