import { RawType } from "./Types";
export var ServiceEntrant;
(function (ServiceEntrant) {
    ServiceEntrant[ServiceEntrant["NONE"] = 0] = "NONE";
    ServiceEntrant[ServiceEntrant["AERIAL"] = 1] = "AERIAL";
    ServiceEntrant[ServiceEntrant["BURIED"] = 2] = "BURIED";
})(ServiceEntrant || (ServiceEntrant = {}));
var ServiceEntrantValues = [];
ServiceEntrantValues[ServiceEntrant.NONE] = 0;
ServiceEntrantValues[ServiceEntrant.AERIAL] = 40000;
ServiceEntrantValues[ServiceEntrant.BURIED] = 20000;
export var getServiceEntrant = function (service) { return ServiceEntrantValues[service] || ServiceEntrantValues[ServiceEntrant.NONE]; };
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case ServiceEntrant.BURIED: return 2;
        case ServiceEntrant.AERIAL: return 1;
        default: return 0;
    }
};
var transformInto = function (value) {
    if (!value)
        return ServiceEntrant.NONE;
    value = parseInt(value);
    switch (value) {
        case 2: return ServiceEntrant.BURIED;
        case 1: return ServiceEntrant.AERIAL;
        default: return ServiceEntrant.NONE;
    }
};
export var TypeServiceEntrant = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=ServiceEntrant.js.map