import { RawType } from "./Types";
export var ServiceType;
(function (ServiceType) {
    ServiceType[ServiceType["NONE"] = 0] = "NONE";
    ServiceType[ServiceType["POWER_OR_COMMUNICATION"] = 1] = "POWER_OR_COMMUNICATION";
    ServiceType[ServiceType["GAZ_WATER"] = 2] = "GAZ_WATER";
})(ServiceType || (ServiceType = {}));
var ServiceTypeValues = [];
ServiceTypeValues[ServiceType.NONE] = 0;
ServiceTypeValues[ServiceType.POWER_OR_COMMUNICATION] = 0.01;
ServiceTypeValues[ServiceType.GAZ_WATER] = 0.1;
export var getServiceType = function (service) { return ServiceTypeValues[service] || ServiceTypeValues[ServiceType.NONE]; };
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case ServiceType.GAZ_WATER: return 2;
        case ServiceType.POWER_OR_COMMUNICATION: return 1;
        default: return 0;
    }
};
var transformInto = function (value) {
    if (!value)
        return ServiceType.NONE;
    value = parseInt(value);
    switch (value) {
        case 2: return ServiceType.GAZ_WATER;
        case 1: return ServiceType.POWER_OR_COMMUNICATION;
        default: return ServiceType.NONE;
    }
};
export var TypeServiceType = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=ServiceType.js.map