import { RawType } from "./Types";
export var State;
(function (State) {
    State[State["DEFECTIVE"] = 0] = "DEFECTIVE";
    State[State["BAD"] = 1] = "BAD";
    State[State["GOOD"] = 2] = "GOOD";
    State[State["NEW"] = 3] = "NEW";
    State[State["NA"] = 4] = "NA";
    State[State["OTHER"] = 5] = "OTHER";
})(State || (State = {}));
var transformFrom = function (value) {
    if (!value)
        return 0;
    switch (value) {
        case State.OTHER: return 5;
        case State.NA: return 4;
        case State.NEW: return 3;
        case State.GOOD: return 2;
        case State.BAD: return 1;
        default: return 0;
    }
};
var transformInto = function (value) {
    if (!value)
        return State.DEFECTIVE;
    value = parseInt(value);
    switch (value) {
        case 5: return State.OTHER;
        case 4: return State.NA;
        case 3: return State.NEW;
        case 2: return State.GOOD;
        case 1: return State.BAD;
        default: return State.DEFECTIVE;
    }
};
export var TypeStateType = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
//# sourceMappingURL=State.js.map