import { TransformInto } from "./FieldHelper";
export declare enum RawType {
    Integer = "INTEGER",
    Text = "TEXT",
    Real = "REAL",
    BigInt = "BIGINT",
    Bool = "TINYINT(1)"
}
export declare enum Argument {
    DefaultNull = "DEFAULT NULL",
    DefaultNonNull = "DEFAULT NON NULL",
    DefaultZero = "DEFAULT 0",
    None = ""
}
export interface Type {
    type: RawType;
    transformIntoTable: TransformInto<any>;
    transformFromTable: TransformInto<any>;
}
export interface ColumnAnnotation {
    type: Type;
    option?: Argument;
    primary?: boolean;
    foreign?: boolean;
    index?: boolean;
    local_only?: boolean;
    mandatory_local?: boolean;
    assets?: boolean;
    in_verification?: boolean;
}
export declare const TypeId: Type;
export declare const TypeBoolean: Type;
export declare const TypeText: Type;
export declare const TypeTextKey: Type;
export declare const TypeInteger: Type;
export declare const TypeBigInt: Type;
export declare const TypeDate: Type;
export declare const TypeReal: Type;
export declare const TypeForeign: Type;
export declare const TypeAssetType: Type;
export declare const TypeMaterialType: Type;
export declare const TypeParatonnerreType: Type;
export declare const TypeSectionType: Type;
export declare const TypeEquipotentialSectionType: Type;
export declare const TypeInstallationType: Type;
export interface ColumnAnnotation {
    type: Type;
    option?: Argument;
    primary?: boolean;
    index?: boolean;
}
