import { transformIntoNumber, transformIntoText, transformIntoDate, transformFromAssetType, transformIntoAssetType, transformIntoReal, transformIntoTextKey, transformIntoBoolean } from "./FieldHelper";
import { transformFromMaterialType, transformIntoMaterialType, transformFromParatonnerreType, transformIntoParatonnerreType } from "./MaterialType";
import { transformFromSectionType, transformIntoSectionType } from "./SectionType";
import { transformInstallationTypeIntoNumber, transformNumberIntoInstallationType } from "./InstallationType";
import { transformFromEquipotentialSectionType, transformIntoEquipotentialSectionType } from "./EquipotentailSectionType";
export var RawType;
(function (RawType) {
    RawType["Integer"] = "INTEGER";
    RawType["Text"] = "TEXT";
    RawType["Real"] = "REAL";
    RawType["BigInt"] = "BIGINT";
    RawType["Bool"] = "TINYINT(1)";
})(RawType || (RawType = {}));
export var Argument;
(function (Argument) {
    Argument["DefaultNull"] = "DEFAULT NULL";
    Argument["DefaultNonNull"] = "DEFAULT NON NULL";
    Argument["DefaultZero"] = "DEFAULT 0";
    Argument["None"] = "";
})(Argument || (Argument = {}));
export var TypeId = {
    type: RawType.Integer,
    transformIntoTable: transformIntoNumber,
    transformFromTable: transformIntoNumber
};
export var TypeBoolean = {
    type: RawType.Bool,
    transformIntoTable: transformIntoBoolean,
    transformFromTable: transformIntoBoolean
};
export var TypeText = {
    type: RawType.Text,
    transformIntoTable: transformIntoText,
    transformFromTable: transformIntoText
};
export var TypeTextKey = {
    type: RawType.Text,
    transformIntoTable: transformIntoTextKey,
    transformFromTable: transformIntoTextKey
};
export var TypeInteger = {
    type: RawType.Integer,
    transformIntoTable: transformIntoNumber,
    transformFromTable: transformIntoNumber
};
export var TypeBigInt = {
    type: RawType.BigInt,
    transformIntoTable: transformIntoNumber,
    transformFromTable: transformIntoNumber
};
export var TypeDate = {
    type: RawType.BigInt,
    transformIntoTable: transformIntoNumber,
    transformFromTable: transformIntoDate
};
export var TypeReal = {
    type: RawType.Real,
    transformFromTable: transformIntoReal,
    transformIntoTable: transformIntoReal
};
export var TypeForeign = {
    type: RawType.Integer,
    transformIntoTable: transformIntoNumber,
    transformFromTable: transformIntoNumber
};
export var TypeAssetType = {
    type: RawType.Text,
    transformIntoTable: transformFromAssetType,
    transformFromTable: transformIntoAssetType
};
export var TypeMaterialType = {
    type: RawType.Text,
    transformIntoTable: transformFromMaterialType,
    transformFromTable: transformIntoMaterialType
};
export var TypeParatonnerreType = {
    type: RawType.Text,
    transformIntoTable: transformFromParatonnerreType,
    transformFromTable: transformIntoParatonnerreType
};
export var TypeSectionType = {
    type: RawType.Text,
    transformIntoTable: transformFromSectionType,
    transformFromTable: transformIntoSectionType
};
export var TypeEquipotentialSectionType = {
    type: RawType.Text,
    transformIntoTable: transformFromEquipotentialSectionType,
    transformFromTable: transformIntoEquipotentialSectionType
};
export var TypeInstallationType = {
    type: RawType.Integer,
    transformIntoTable: transformInstallationTypeIntoNumber,
    transformFromTable: transformNumberIntoInstallationType
};
//# sourceMappingURL=Types.js.map