var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { TypeId, Argument, TypeTextKey, TypeBoolean, TypeDate } from '../helpers/Types';
import { getColumnType, column, getChildren } from '../helpers/Decorators';
import DbDescriptor from '../table/DbDescriptor';
import { EventEmitter2 } from "eventemitter2";
import Query from "../helpers/Query";
import DBCache from '../helpers/DBCache';
import Queue from '../../utils/queue';
import createLogger from '../../utils/Logger';
;
var models = new Map();
var queue = new Queue();
//we create a simple class which will :
// - contains a uuid field
// - contains a synced field
// and a constructor provided with at least a json holding the value to populate
//
//The class is now responsible to fire update event
//to be able to receive such event, the object can set to the update event from EventEmitter2
var Abstract = /** @class */ (function () {
    function Abstract(name, db_values) {
        var _this = this;
        this.event = new EventEmitter2();
        // default field for any syncable classes
        this.id = undefined;
        this.parent_id = undefined;
        this.uuid = "";
        this.deleted = false;
        this.locally_updated = false;
        this.optional_verification_validated = false;
        this.version = "";
        this.date = new Date(0);
        this.date_unknown = false;
        this._log = false;
        this.assets_key = function () { return []; };
        this.is_verification = function (key) { return !!_this.verification_keys().find(function (k) { return k == key; }); };
        this.default_key = undefined;
        this.db_values = db_values;
        this.logger = createLogger(name);
    }
    Abstract.prototype.getOrCreateDbDescriptor = function (instance) {
        var table_name = ((instance || {}).constructor || {}).name;
        var table = undefined;
        if (models.has(table_name))
            table = models.get(table_name);
        if (!table) {
            var keys = this.allKeys();
            console.log("getOrCreateDbDescriptor " + table_name + " ::", keys);
            var new_table_1 = new DbDescriptor(table_name.split("_")[0]);
            models.set(table_name, new_table_1);
            keys.forEach(function (field) {
                var column = getColumnType(instance, field);
                var child = getChildren(instance, field);
                if (column) {
                    new_table_1.add(field, column);
                    new_table_1.addColumnAnnotation(field, column);
                }
                if (child)
                    new_table_1.addColumnChild(field, child);
            });
            table = new_table_1;
        }
        return table;
    };
    Abstract.prototype.getDate = function () {
        this.enforceDate();
        return this.date;
    };
    Abstract.prototype.enforceDate = function () {
        if (this.date && typeof this.date === "string") {
            try {
                this.date = new Date();
            }
            catch (e) {
                //TODO send error report
            }
        }
        else {
            this.date = new Date();
        }
    };
    Abstract.prototype.merge = function (json, override) {
        var _this = this;
        var _a;
        if (!json)
            return this;
        var locally_updated = this.locally_updated;
        var json_keys = Object.keys(json);
        this.annotated_columns().forEach(function (binder) {
            if (binder.value.local_only)
                return;
            var key = binder.key, value = binder.value;
            var type = value.type;
            var left = _this[key];
            var right = undefined != json[key] && !!json_keys.find(function (k) { return k == key; }) ? type.transformFromTable(json[key]) : undefined;
            if ((!!override || !locally_updated) && undefined != right && left !== right) {
                //console.log(`differences for ${key}`, {left, right});
                _this[key] = right;
            }
            else {
                //console.log(`differences not found, skipping`, {locally_updated});
            }
        });
        var log = !!json.verifications;
        this.annotated_children().forEach(function (binder) {
            var key = binder.key, value = binder.value;
            var array_this = _this[key];
            var array_from = json[key] || [];
            array_from.forEach(function (from_json) {
                var existing = _this.findInJson(from_json, array_this);
                if (!existing) {
                    console.warn("sub object not found for " + key + "... creating !");
                    var instance = new value(from_json);
                    instance.init(instance);
                    instance.merge(from_json);
                    array_this.push(instance);
                    instance.parent_id = _this.id;
                    console.warn("sub object not found for " + key + "... created !", instance);
                }
                else {
                    console.warn("found sub object for " + key + "... merging");
                    existing.merge(from_json);
                }
            });
        });
        var primary = (_a = this.descriptor) === null || _a === void 0 ? void 0 : _a.columns.find(function (c) { return c.isPrimary(); });
        var id_value = primary ? this[primary.name()] : undefined;
        //if(id_value) DBCache.set(this.descriptor.name, id_value, this);
        //console.log("merging done for current object");
        return this;
    };
    Abstract.prototype.findInJson = function (from_json, instances) {
        return (instances || []).find(function (i) { return i && i.uuid === from_json.uuid; });
    };
    Abstract.prototype.init = function (instance) {
        var _this = this;
        var table_name = ((instance || {}).constructor || {}).name;
        if (!table_name)
            throw "invalid model registering process";
        this.descriptor = this.getOrCreateDbDescriptor(instance);
        this.annotated_children().forEach(function (holder) {
            var key = holder.key;
            if (!_this[key])
                _this[key] = [];
            var self = _this;
            _this[key].push = function (item) {
                item.parent_id = self.id;
                //@ts-ignore
                return Array.prototype.push.apply(this, arguments);
            };
        });
        return this.descriptor;
    };
    Abstract.prototype.populate = function () {
        var _this = this;
        var boundTogethers = this.annotated_children();
        if (this.id) {
            return Promise.all(boundTogethers.map(function (bound) { return _this.populateChildrenForKey(bound.key, bound.value); })).then(function () { return _this; });
        }
        return Promise.resolve(this);
    };
    Abstract.prototype.log = function (enable) {
        this._log = enable;
    };
    Abstract.prototype.transaction = function () {
        var _this = this;
        return Query.query.transaction().then(function (tx) {
            if (!tx)
                throw _this.constructor.name + " :: transaction is invalid";
            return tx;
        });
    };
    Abstract.prototype._save = function (transaction, recursive) {
        if (recursive === void 0) { recursive = true; }
        return __awaiter(this, void 0, void 0, function () {
            var descriptor, primary, columns, values, updated_column, id_value, query, args, result, columns_name, question, result, wait_for_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        descriptor = this.descriptor;
                        if (!descriptor)
                            return [2 /*return*/, this];
                        primary = descriptor.columns.find(function (c) { return c.isPrimary(); });
                        if (!primary)
                            throw "table does not have primary key " + this.constructor.name + JSON.stringify(this.db_values);
                        columns = descriptor.columns.filter(function (c) { return !c.isPrimary(); });
                        values = columns.map(function (c) {
                            var column = descriptor.column(c.name());
                            return column ? column.value.type.transformIntoTable(_this[c.name()]) : undefined;
                        });
                        if (!(this[primary.name()] && this[primary.name()] > 0)) return [3 /*break*/, 2];
                        updated_column = columns.map(function (c) { return "`" + c.name() + "`=?"; }).join(", ");
                        id_value = this[primary.name()];
                        query = "UPDATE " + descriptor.name + " SET " + updated_column + " WHERE `" + primary.name() + "`=?";
                        args = __spreadArrays(values, [id_value]);
                        !!this._log && console.log(query);
                        !!this._log && console.log(args);
                        return [4 /*yield*/, Query.query.execute(transaction, query, args)];
                    case 1:
                        result = _a.sent();
                        !!this._log && console.log("result", result);
                        return [3 /*break*/, 4];
                    case 2:
                        columns_name = columns.map(function (c) { return "`" + c.name() + "`"; }).join(", ");
                        question = columns.map(function () { return "?"; }).join(", ");
                        return [4 /*yield*/, Query.query.execute(transaction, "INSERT INTO " + descriptor.name + " (" + columns_name + ") VALUES (" + question + ")", values)];
                    case 3:
                        result = _a.sent();
                        if (result && result.insertId) {
                            this[primary.name()] = result.insertId;
                            //DBCache.set(descriptor.name, result.insertId, this);
                            DBCache.cache(descriptor.name, this);
                        }
                        _a.label = 4;
                    case 4:
                        if (!recursive) return [3 /*break*/, 6];
                        wait_for_1 = [];
                        this.annotated_children().forEach(function (binder) {
                            var array_this = _this[binder.key];
                            (array_this || []).forEach(function (item) {
                                if (item && !!item._save) {
                                    item.parent_id = _this.id;
                                    wait_for_1.push(item);
                                }
                            });
                        });
                        return [4 /*yield*/, Promise.all(wait_for_1.map(function (w) { return w._save(transaction, recursive); }))];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6: return [2 /*return*/, this];
                }
            });
        });
    };
    Abstract.prototype.save = function (recursive) {
        var _this = this;
        if (recursive === void 0) { recursive = true; }
        return this.transaction().then(function (transaction) { return _this._save(transaction, recursive); });
        //return queue.enqueuePromise((resolve, reject) => {
        //    this.save(recursive).then(result => resolve(this)).catch(err => reject(err));
        //});
    };
    Abstract.prototype.fireUpdate = function () {
        this.event.emit("update", this);
    };
    Abstract.prototype.populateChildrenForKey = function (key, klass) {
        var _this = this;
        if (!this.id) {
            var self_1 = this;
            this[key] = [];
            this[key].push = function (item) {
                item.parent_id = self_1.id;
                //@ts-ignore
                return Array.prototype.push.apply(this, arguments);
            };
            return Promise.resolve(this);
        }
        return Query.query.children(klass, this.id)
            .then(function (children) {
            var self = _this;
            _this[key] = [];
            _this[key].push = function (item) {
                item.parent_id = self.id;
                //@ts-ignore
                return Array.prototype.push.apply(this, arguments);
            };
            var arr = _this[key];
            children.forEach(function (c) {
                c.parent_id = _this.id;
                arr.push(c);
            });
            return Promise.all(arr.map(function (c) { return c.populate(); }));
        }).then(function () { return _this; });
    };
    Abstract.prototype.json = function (include_local) {
        var _this = this;
        var json = {};
        this.annotated_columns().forEach(function (annotation) {
            var column = annotation.value;
            if (column && (!column.local_only || include_local) && !column.mandatory_local) {
                json[annotation.key] = column.type.transformIntoTable(_this[annotation.key]);
            }
        });
        var descriptor = this.descriptor;
        json.klass = descriptor ? descriptor.name : this.constructor.name;
        return json;
    };
    Abstract.prototype.verification_keys = function () {
        return this.annotated_columns().filter(function (c) { return c.value.in_verification; }).map(function (c) { return c.key; });
    };
    Abstract.prototype.full_json = function (include_local, exclude_assets) {
        var _this = this;
        var json = this.json(include_local);
        this.annotated_children().forEach(function (_a) {
            var key = _a.key;
            var array = _this[key] || [];
            json[key] = array.map(function (item) { return item.full_json(include_local, exclude_assets); });
        });
        //TODO improve algorithm by including it inside above annotated_children
        if (!!exclude_assets) {
            (this.assets_key() || []).map(function (k) { return json[k] = []; });
        }
        return json;
    };
    Abstract.prototype.clone = function () {
        return this.full_json();
    };
    Abstract.prototype.keys = function () {
        return Object.keys(this);
    };
    Abstract.prototype.allKeys = function () {
        var keys = Object.keys(this);
        var above = this.keys();
        above.forEach(function (key) {
            if (typeof key === "string" && !keys.includes(key))
                keys.push(key);
        });
        return keys;
    };
    Abstract.prototype.from = function (from) {
        var _this = this;
        if (from) {
            var columns = Object.keys(from).map(function (field) { return ({ field: field, column: getColumnType(_this, field) }); }).filter(function (c) { return c.field && c.column; });
            columns.forEach(function (_a) {
                var column = _a.column, field = _a.field;
                if (column) {
                    _this[field] = column.type.transformFromTable(from[field]);
                    //console.log(from[field] +"->"+this[field]);
                }
                else {
                    console.error(_this.constructor.name + " invalid column found for " + field, { field: field, column: column });
                }
            });
        }
    };
    Abstract.prototype.getDescriptionKeys = function (is_simulation) {
        return [];
    };
    Abstract.prototype.annotated_columns = function () {
        var _a;
        return ((_a = this.descriptor) === null || _a === void 0 ? void 0 : _a.annotated_columns()) || [];
    };
    Abstract.prototype.annotated_children = function () {
        var _a;
        return ((_a = this.descriptor) === null || _a === void 0 ? void 0 : _a.annotated_children()) || [];
    };
    Abstract.prototype.onUpdate = function (listener) {
        return this.addListener("update", listener);
    };
    Abstract.prototype.addListener = function (event, listener) {
        var _this = this;
        this.event.addListener(event, listener);
        return function () {
            _this.event.removeListener(event, listener);
        };
    };
    __decorate([
        column({ type: TypeId, primary: true, local_only: true, mandatory_local: true }),
        __metadata("design:type", Object)
    ], Abstract.prototype, "id", void 0);
    __decorate([
        column({ type: TypeId, foreign: true, index: true, local_only: true, mandatory_local: true }),
        __metadata("design:type", Object)
    ], Abstract.prototype, "parent_id", void 0);
    __decorate([
        column({ type: TypeTextKey, index: true, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Abstract.prototype, "uuid", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull }),
        __metadata("design:type", Boolean)
    ], Abstract.prototype, "deleted", void 0);
    __decorate([
        column({ type: TypeBoolean, local_only: true }),
        __metadata("design:type", Boolean)
    ], Abstract.prototype, "locally_updated", void 0);
    __decorate([
        column({ type: TypeBoolean }),
        __metadata("design:type", Boolean)
    ], Abstract.prototype, "optional_verification_validated", void 0);
    __decorate([
        column({ type: TypeTextKey, local_only: false }),
        __metadata("design:type", String)
    ], Abstract.prototype, "version", void 0);
    __decorate([
        column({ type: TypeDate }),
        __metadata("design:type", Date)
    ], Abstract.prototype, "date", void 0);
    __decorate([
        column({ type: TypeBoolean }),
        __metadata("design:type", Boolean)
    ], Abstract.prototype, "date_unknown", void 0);
    return Abstract;
}());
export { Abstract };
//# sourceMappingURL=Abstract.js.map