import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
import AntennaAsset from "./AntennaAsset";
export interface AntennaParams extends UUIDable {
    height?: string;
    description?: string;
    latitude?: number;
    longitude?: number;
}
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
export default class Antenna extends Abstract<AntennaParams, Antenna> {
    assets: AntennaAsset[];
    height: number;
    description: string;
    latitude: number;
    longitude: number;
    constructor(values: AntennaParams);
    protected assets_key: () => string[];
    getDescriptionKeys(): (keyof Antenna)[];
    protected keys(): (keyof Antenna)[];
}
