import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
import BridgeAsset from "./BridgeAsset";
import Antenna from "./Antenna";
export interface BridgeParams extends UUIDable {
    serial_number?: string;
    building?: string;
    brand?: string;
    model?: string;
    height?: string;
    description?: string;
    latitude?: number;
    longitude?: number;
}
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
export default class Bridge extends Abstract<BridgeParams, Bridge> {
    assets: BridgeAsset[];
    validAssets(): BridgeAsset[];
    antennas: Antenna[];
    validAntennas(): Antenna[];
    building: string;
    latitude: number;
    longitude: number;
    serial_number: string;
    brand: string;
    model: string;
    height: string;
    description: string;
    constructor(values: BridgeParams);
    protected assets_key: () => string[];
    getDescriptionKeys(is_simulation?: boolean): (keyof Bridge)[];
}
