import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
import { State } from "../helpers/State";
import BuildingItemAsset from "./BuildingItemAsset";
import { Position } from "../../webservice/Weather";
export interface BuildingItemParams extends UUIDable {
    latitudes?: string;
    longitudes?: string;
    description?: string;
    name?: string;
    delta_height?: number;
    height?: number;
    state?: State;
    state_description?: string;
    delta_latitude_meter?: number;
    delta_longitude_meter?: number;
}
export default class BuildingItem extends Abstract<BuildingItemParams, BuildingItem> implements BuildingItemParams {
    assets: BuildingItemAsset[];
    validAssets(): BuildingItemAsset[];
    delta_height: number | undefined;
    height: number | undefined;
    description: string;
    name: string;
    latitudes: string | undefined;
    longitudes: string | undefined;
    state: State;
    state_description: string | undefined;
    delta_latitude_meter: number;
    delta_longitude_meter: number;
    constructor(values: BuildingItemParams);
    points(): Position[];
    protected assets_key: () => string[];
    getDescriptionKeys(is_simulation?: boolean): (keyof BuildingItem)[];
    setDelta(latitude: number, longitude: number): void;
    deltaMeter(): {
        latitude: number;
        longitude: number;
    };
    deltaKm(): {
        latitude: number;
        longitude: number;
    };
}
