var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Abstract } from "./Abstract";
import { Argument, TypeText, TypeReal } from "../helpers/Types";
import { column, children } from "../helpers/Decorators";
import { State, TypeStateType } from "../helpers/State";
import BuildingItemAsset from "./BuildingItemAsset";
import { distinctsAbstract } from "../../utils/Array";
var BuildingItem = /** @class */ (function (_super) {
    __extends(BuildingItem, _super);
    function BuildingItem(values) {
        var _this = _super.call(this, "BuildingItem", values) || this;
        _this.assets = [];
        _this.delta_height = 0;
        _this.height = 0;
        _this.description = "";
        _this.name = "";
        _this.latitudes = "";
        _this.longitudes = "";
        _this.state = State.DEFECTIVE;
        _this.state_description = "";
        _this.delta_latitude_meter = 0;
        _this.delta_longitude_meter = 0;
        _this.assets_key = function () { return ["assets"]; };
        _this.from(values);
        return _this;
    }
    BuildingItem.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    BuildingItem.prototype.points = function () {
        var positions = [];
        try {
            var split_lat = (this.latitudes || "").split(",");
            var split_long = (this.longitudes || "").split(",");
            if (split_lat.length == split_long.length) {
                for (var i = 0; i < split_long.length; i++) {
                    var latitude = parseFloat(split_lat[i]);
                    var longitude = parseFloat(split_long[i]);
                    if (!isNaN(latitude) && !isNaN(longitude)) {
                        positions.push({ latitude: latitude, longitude: longitude });
                    }
                }
            }
            else {
                console.log("positions for building's item are incorrects");
            }
        }
        catch (e) {
            console.log("positions for building's item exception", e);
        }
        return positions;
    };
    BuildingItem.prototype.getDescriptionKeys = function (is_simulation) {
        return ["name"];
    };
    BuildingItem.prototype.setDelta = function (latitude, longitude) {
        this.delta_latitude_meter = latitude;
        this.delta_longitude_meter = longitude;
    };
    BuildingItem.prototype.deltaMeter = function () {
        return {
            latitude: this.delta_latitude_meter,
            longitude: this.delta_longitude_meter
        };
    };
    BuildingItem.prototype.deltaKm = function () {
        if (!this.delta_latitude_meter && !this.delta_longitude_meter)
            return {
                latitude: 0,
                longitude: 0
            };
        return {
            latitude: this.delta_latitude_meter * 1. / 1000,
            longitude: this.delta_longitude_meter * 1. / 1000
        };
    };
    __decorate([
        children(BuildingItemAsset),
        __metadata("design:type", Array)
    ], BuildingItem.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], BuildingItem.prototype, "delta_height", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], BuildingItem.prototype, "height", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", String)
    ], BuildingItem.prototype, "description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", String)
    ], BuildingItem.prototype, "name", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], BuildingItem.prototype, "latitudes", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], BuildingItem.prototype, "longitudes", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Number)
    ], BuildingItem.prototype, "state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], BuildingItem.prototype, "state_description", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], BuildingItem.prototype, "delta_latitude_meter", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], BuildingItem.prototype, "delta_longitude_meter", void 0);
    return BuildingItem;
}(Abstract));
export default BuildingItem;
//# sourceMappingURL=BuildingItem.js.map