var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { Abstract } from "./Abstract";
import { Argument, TypeMaterialType, TypeText, TypeBoolean } from "../helpers/Types";
import { children, column } from "../helpers/Decorators";
import ConductorAsset from "./ConductorAsset";
import GroundingComponent from "./GroundingComponent";
import CounterComponent from "./CounterComponent";
import { TypeDimensionType } from "../helpers/Dimension";
import { TypeStateType } from "../helpers/State";
import ConductorSectionComponent from "./ConductorSectionComponent";
import { distinctsAbstract } from "../../utils/Array";
import { hasIssues } from "./FailureObject";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var ConductorComponent = /** @class */ (function (_super) {
    __extends(ConductorComponent, _super);
    function ConductorComponent(values) {
        var _this = _super.call(this, "ConductorComponent", values) || this;
        _this.counters = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.assets = [];
        _this.groundings = [];
        _this.sections = [];
        _this.dimension = undefined;
        _this.description = undefined;
        _this.material = undefined;
        _this.brand = undefined;
        _this.has_counter = false;
        _this.has_sign = false;
        _this.has_sign_comment = "";
        _this.joint_control = false;
        _this.joint_control_comment = "";
        _this.joint_control_marking = "";
        _this.joint_control_state = undefined;
        _this.has_protection_shield = false;
        _this.has_protection_shield_comment = "";
        _this.has_protection_shield_state = undefined;
        _this.has_no_horizontal_support = false;
        _this.path_as_straight_as_possible = false;
        _this.path_as_straight_as_possible_comment = undefined;
        _this.curve_respected = false;
        _this.curve_respected_comment = "";
        _this.state = 0;
        _this.state_description = undefined;
        _this.horizontal_equipotential_recovery = false;
        _this.horizontal_equipotential_recovery_comment = undefined;
        _this.assets_key = function () { return ["assets"]; };
        _this.default_key = "description";
        _this.setFixation = function (fixation) { return _this.fixation = fixation; };
        _this.from(values);
        return _this;
    }
    ConductorComponent.prototype.validCounters = function () {
        return distinctsAbstract(this.counters, true);
    };
    ConductorComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    ConductorComponent.prototype.hasIssuesOrChildrenIssues = function () {
        if (this.hasIssues())
            return true;
        if (hasIssues(this.validCounters()))
            return true;
        if (hasIssues(this.validGroundings()))
            return true;
        if (hasIssues(this.validSections()))
            return true;
        return false;
    };
    ConductorComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    ConductorComponent.prototype.validGroundings = function () {
        return distinctsAbstract(this.groundings, true);
    };
    ConductorComponent.prototype.validSections = function () {
        return distinctsAbstract(this.sections, true);
    };
    ConductorComponent.prototype.verification_keys = function () {
        var keys = _super.prototype.verification_keys.call(this);
        /*
        if(!this.fixation || !this.fixation.is_ground()) return keys;
        return keys.filter(k => {
            return k != "vertical_path"
            && k != "vertical_support"
            && k != "length_vertical"
            && k != "vertical_number_support_per_meter"
            && k != "vertical_number_support_per_meter_state"
            && k != "vertical_number_support_per_meter_state_comment"
            && k != "path_as_straight_as_possible"
            && k != "path_as_straight_as_possible_comment"
            && k != "equipotential_recovery"
            && k != "equipotential_recovery_comment"
        });
        */
        return keys;
    };
    ConductorComponent.prototype.getDescriptionKeys = function (is_simulation) {
        var array = [
            "dimension",
            "description",
            "material",
            "brand",
            "state",
            "state_description",
            "has_counter",
            "has_sign",
            "has_sign_comment",
            "joint_control",
            "joint_control_comment",
            "has_protection_shield_comment",
            "horizontal_equipotential_recovery",
            "horizontal_equipotential_recovery_comment"
        ];
        if (!is_simulation) {
            return __spreadArrays(array, [
                "joint_control_marking",
                "joint_control_state",
                "has_protection_shield",
                "has_protection_shield_state",
                "has_issues",
                "has_issues_description"
            ]);
        }
        return array;
    };
    __decorate([
        children(CounterComponent),
        __metadata("design:type", Array)
    ], ConductorComponent.prototype, "counters", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_issues_description", void 0);
    __decorate([
        children(ConductorAsset),
        __metadata("design:type", Array)
    ], ConductorComponent.prototype, "assets", void 0);
    __decorate([
        children(GroundingComponent),
        __metadata("design:type", Array)
    ], ConductorComponent.prototype, "groundings", void 0);
    __decorate([
        children(ConductorSectionComponent),
        __metadata("design:type", Array)
    ], ConductorComponent.prototype, "sections", void 0);
    __decorate([
        column({ type: TypeDimensionType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "dimension", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "description", void 0);
    __decorate([
        column({ type: TypeMaterialType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "material", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "brand", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_counter", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_sign", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_sign_comment", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "joint_control", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "joint_control_comment", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "joint_control_marking", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "joint_control_state", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_protection_shield", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_protection_shield_comment", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_protection_shield_state", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "has_no_horizontal_support", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "path_as_straight_as_possible", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "path_as_straight_as_possible_comment", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "curve_respected", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "curve_respected_comment", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "state_description", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "horizontal_equipotential_recovery", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorComponent.prototype, "horizontal_equipotential_recovery_comment", void 0);
    return ConductorComponent;
}(Abstract));
export default ConductorComponent;
//# sourceMappingURL=ConductorComponent.js.map