var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Abstract } from "./Abstract";
import { Argument, TypeText, TypeInteger, TypeBoolean, TypeReal } from "../helpers/Types";
import { children, column } from "../helpers/Decorators";
import { TypeStateType } from "../helpers/State";
import ConductorSectionAsset from "./ConductorSectionAsset";
import { distinctsAbstract } from "../../utils/Array";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var ConductorSectionComponent = /** @class */ (function (_super) {
    __extends(ConductorSectionComponent, _super);
    function ConductorSectionComponent(values) {
        var _this = _super.call(this, "ConductorSectionComponent", values) || this;
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.is_vertical = false;
        _this.state = 0;
        _this.state_description = undefined;
        _this.latitudes = "";
        _this.longitudes = "";
        _this.support = undefined;
        _this.number_support_per_meter = undefined;
        _this.length = undefined;
        _this.assets_key = function () { return ["assets"]; };
        _this.default_key = "description";
        _this.from(values);
        return _this;
    }
    ConductorSectionComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    ConductorSectionComponent.prototype.hasIssuesOrChildrenIssues = function () {
        return this.hasIssues();
    };
    ConductorSectionComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    ConductorSectionComponent.prototype.points = function () {
        var points = [];
        if (this.latitudes && this.longitudes) {
            var latitudes = this.latitudes.split(",");
            var longitudes = this.longitudes.split(",");
            var i = 0;
            while (i < latitudes.length && i < longitudes.length) {
                points.push({
                    latitude: parseFloat(latitudes[i]),
                    longitude: parseFloat(longitudes[i])
                });
                i++;
            }
        }
        return points;
    };
    ConductorSectionComponent.prototype.getDescriptionKeys = function (is_simulation) {
        if (is_simulation)
            return ["support"];
        return [
            "state_description",
            "has_issues",
            "has_issues_description"
        ];
    };
    __decorate([
        children(ConductorSectionAsset),
        __metadata("design:type", Array)
    ], ConductorSectionComponent.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "is_vertical", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "state_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "latitudes", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "longitudes", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "support", void 0);
    __decorate([
        column({ type: TypeInteger, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "number_support_per_meter", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ConductorSectionComponent.prototype, "length", void 0);
    return ConductorSectionComponent;
}(Abstract));
export default ConductorSectionComponent;
//# sourceMappingURL=ConductorSectionComponent.js.map