var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Abstract } from "./Abstract";
import { Argument, TypeText, TypeInteger, TypeBoolean } from "../helpers/Types";
import { TypeDisplayType } from "../helpers/DisplayType";
import { TypeStateType } from "../helpers/State";
import { children, column } from "../helpers/Decorators";
import CounterAsset from "./CounterAsset";
import { TypeAlimentationType } from "../helpers/AlimentationType";
import { distinctsAbstract } from "../../utils/Array";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var CounterComponent = /** @class */ (function (_super) {
    __extends(CounterComponent, _super);
    function CounterComponent(values) {
        var _this = _super.call(this, "CounterComponent", values) || this;
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.serial_number = undefined;
        _this.brand = undefined;
        _this.description = undefined;
        _this.display = undefined;
        _this.alimentation = undefined;
        _this.count = 0;
        _this.state = 0;
        _this.has_memory = false;
        _this.will_communicate = false;
        _this.assets_key = function () { return ["assets"]; };
        _this.from(values);
        if (!_this.will_communicate)
            _this.will_communicate = false;
        return _this;
    }
    CounterComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    CounterComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    CounterComponent.prototype.hasIssuesOrChildrenIssues = function () {
        return this.hasIssues();
    };
    CounterComponent.prototype.getDescriptionKeys = function (is_simulation) {
        if (is_simulation)
            return ["description"];
        return [
            "brand",
            "display",
            "description",
            "alimentation",
            "serial_number",
            "state",
            "count",
            "has_issues",
            "has_issues_description"
            //"has_memory"
        ];
    };
    __decorate([
        children(CounterAsset),
        __metadata("design:type", Array)
    ], CounterComponent.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "serial_number", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "brand", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "description", void 0);
    __decorate([
        column({ type: TypeDisplayType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "display", void 0);
    __decorate([
        column({ type: TypeAlimentationType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "alimentation", void 0);
    __decorate([
        column({ type: TypeInteger, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "count", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "state", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "has_memory", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], CounterComponent.prototype, "will_communicate", void 0);
    return CounterComponent;
}(Abstract));
export default CounterComponent;
//# sourceMappingURL=CounterComponent.js.map