import { EventEmitter2 } from 'eventemitter2';
export declare enum CommunicationType {
    INTELLIGENT = 0,
    SIMPLE = 1,
    NETWORK_INTERFACE = 2
}
export default class Device extends EventEmitter2 {
    _id: number;
    _serial: string | undefined | null;
    _internal_serial: string | undefined | null;
    _product_id: number | null;
    _is_demo?: boolean;
    constructor(id: number, serial: string | null, internal_serial: string | null, product_id: number | null, is_demo?: boolean);
    isDemo: () => boolean;
    getId: () => number;
    hasSerial: () => boolean;
    setSerial(serial: string): Device;
    setInternalSerial(internal_serial: string): Device;
    getSerial(): string;
    setProduct(product_id: number): void;
    getProduct(): string;
    getCommunicationType(): CommunicationType;
    hasInternalSerial: () => boolean;
    getInternalSerial(): string;
}
