var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EventEmitter2 } from 'eventemitter2';
export var CommunicationType;
(function (CommunicationType) {
    CommunicationType[CommunicationType["INTELLIGENT"] = 0] = "INTELLIGENT";
    CommunicationType[CommunicationType["SIMPLE"] = 1] = "SIMPLE";
    CommunicationType[CommunicationType["NETWORK_INTERFACE"] = 2] = "NETWORK_INTERFACE";
})(CommunicationType || (CommunicationType = {}));
var Device = /** @class */ (function (_super) {
    __extends(Device, _super);
    function Device(id, serial, internal_serial, product_id, is_demo) {
        var _this = _super.call(this) || this;
        _this.isDemo = function () { return !!_this._is_demo; };
        _this.getId = function () { return _this._id; };
        _this.hasSerial = function () { return !!(_this._serial && _this._serial.length > 0); };
        _this.hasInternalSerial = function () { return !!(_this._internal_serial && _this._internal_serial.length > 0); };
        _this._id = id;
        _this._serial = serial;
        _this._internal_serial = internal_serial;
        _this._product_id = product_id;
        return _this;
    }
    Device.prototype.setSerial = function (serial) {
        this._serial = serial;
        return this;
    };
    Device.prototype.setInternalSerial = function (internal_serial) {
        this._internal_serial = internal_serial;
        return this;
    };
    Device.prototype.getSerial = function () {
        if (this._serial)
            return this._serial.toUpperCase();
        return "";
    };
    Device.prototype.setProduct = function (product_id) {
        this._product_id = product_id;
    };
    Device.prototype.getProduct = function () {
        switch (this._product_id) {
            case 248:
            case 15:
                return "alertairts";
            case 249:
            case 14:
                return "alertairdc";
            case 250:
            case 13:
            case 12:
                return "alertairxt";
            case 255:
            case 8:
                return "donglair";
            case 251:
            case 11:
                return "paratonair";
            case 254:
            case 9:
                return "comptair";
            case 253:
            case 10:
                return "ellips";
            case 252:
            case 7:
                return "routair";
            case 0:
            case 1:
                return "contactair";
        }
        return "";
    };
    Device.prototype.getCommunicationType = function () {
        switch (this._product_id) {
            case 248:
            case 15:
            case 249:
            case 14:
            case 250:
            case 13:
            case 12:
            case 251:
            case 11:
            case 255:
            case 8:
            case 254:
            case 9:
                return CommunicationType.INTELLIGENT;
            case 253:
            case 10:
            case 252:
            case 7:
            case 0:
            case 1:
                return CommunicationType.NETWORK_INTERFACE;
        }
        return CommunicationType.SIMPLE;
    };
    Device.prototype.getInternalSerial = function () {
        if (this._internal_serial)
            return this._internal_serial.toLowerCase();
        return "";
    };
    return Device;
}(EventEmitter2));
export default Device;
//# sourceMappingURL=Device.js.map