var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Abstract } from "./Abstract";
import { Argument, TypeBoolean, TypeReal, TypeText, } from "../helpers/Types";
import { children, column } from "../helpers/Decorators";
import { distinctsAbstract } from "../../utils/Array";
import ElectricalGroundingAsset from "./ElectricalGroundingAsset";
import { MaterialStakeType, TypeMaterialStakeType } from "../helpers/MaterialStakeType";
import { TypeMaterialShortType } from "../helpers/MaterialShortType";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var ElectricalGroundingComponent = /** @class */ (function (_super) {
    __extends(ElectricalGroundingComponent, _super);
    function ElectricalGroundingComponent(values) {
        var _this = _super.call(this, "ElectricalGroundingComponent", values) || this;
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.name = "";
        _this.latitudes = "";
        _this.longitudes = "";
        _this.section = "";
        _this.material = undefined;
        _this.has_stakes = false;
        _this.optional_stakes_height = 0;
        _this.optional_stakes_material = MaterialStakeType.UNKNOWN;
        _this.resistivity = undefined;
        _this.assets_key = function () { return ["assets"]; };
        _this.from(values);
        return _this;
    }
    ElectricalGroundingComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    ElectricalGroundingComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    ElectricalGroundingComponent.prototype.hasIssuesOrChildrenIssues = function () {
        return this.hasIssues();
    };
    ElectricalGroundingComponent.prototype.verification_keys = function () {
        return _super.prototype.verification_keys.call(this);
    };
    ElectricalGroundingComponent.prototype.points = function () {
        var positions = [];
        try {
            var split_lat = (this.latitudes || "").split(",");
            var split_long = (this.longitudes || "").split(",");
            if (split_lat.length == split_long.length) {
                for (var i = 0; i < split_long.length; i++) {
                    var latitude = parseFloat(split_lat[i]);
                    var longitude = parseFloat(split_long[i]);
                    if (!isNaN(latitude) && !isNaN(longitude)) {
                        positions.push({ latitude: latitude, longitude: longitude });
                    }
                }
            }
            else {
                console.log("positions for building are incorrects");
            }
        }
        catch (e) {
            console.log("positions for building exception", e);
        }
        return positions;
    };
    ElectricalGroundingComponent.prototype.getDescriptionKeys = function (is_simulation) {
        return [
            "name",
            "section",
            "material",
            "has_issues",
            "has_issues_description"
        ];
    };
    __decorate([
        children(ElectricalGroundingAsset),
        __metadata("design:type", Array)
    ], ElectricalGroundingComponent.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "name", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "latitudes", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "longitudes", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "section", void 0);
    __decorate([
        column({ type: TypeMaterialShortType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "material", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Boolean)
    ], ElectricalGroundingComponent.prototype, "has_stakes", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "optional_stakes_height", void 0);
    __decorate([
        column({ type: TypeMaterialStakeType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", String)
    ], ElectricalGroundingComponent.prototype, "optional_stakes_material", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ElectricalGroundingComponent.prototype, "resistivity", void 0);
    return ElectricalGroundingComponent;
}(Abstract));
export default ElectricalGroundingComponent;
//# sourceMappingURL=ElectricalGroundingComponent.js.map