import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
import { Position } from "../../webservice/Weather";
import { MaterialType } from "../helpers/MaterialType";
import { State } from "../helpers/State";
import { SectionType } from "../helpers/SectionType";
import { EquipotentialSectionType } from "../helpers/EquipotentailSectionType";
import EquipotentialRecoveryAsset from "./EquipotentialRecoveryAsset";
import { FailureObject } from "./FailureObject";
export interface EquipotentialRecoveryParams extends UUIDable {
    description?: string;
    material?: MaterialType;
    section?: SectionType;
    state?: State;
    latitudes?: string;
    longitudes?: string;
}
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
export default class EquipotentialRecoveryComponent extends Abstract<EquipotentialRecoveryParams, EquipotentialRecoveryComponent> implements FailureObject {
    assets: EquipotentialRecoveryAsset[];
    validAssets(): EquipotentialRecoveryAsset[];
    hasIssues(): boolean;
    hasIssuesOrChildrenIssues(): boolean;
    has_issues: boolean | undefined;
    has_issues_description: string | undefined;
    description: string | undefined;
    material: MaterialType | undefined;
    section: EquipotentialSectionType | undefined;
    state: State | undefined;
    latitudes: string | undefined;
    longitudes: string | undefined;
    constructor(values: EquipotentialRecoveryParams);
    points(): Position[];
    protected assets_key: () => string[];
    getDescriptionKeys(is_simulation?: boolean): (keyof EquipotentialRecoveryComponent)[];
}
