var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { Abstract } from "./Abstract";
import { TypeText, Argument, TypeBoolean } from "../helpers/Types";
import { children, column } from "../helpers/Decorators";
import FixationAsset from "./FixationAsset";
import { TypeSupportType } from "../helpers/SupportType";
import { TypeStateType } from "../helpers/State";
import { TypeFixationType } from "../helpers/FixationType";
import { TypeMaterialSupportType } from "../helpers/MaterialSupportType";
import { FixationSupportType } from "../helpers/FixationSupportType";
import { distinctsAbstract } from "../../utils/Array";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var FixationComponent = /** @class */ (function (_super) {
    __extends(FixationComponent, _super);
    function FixationComponent(values) {
        var _this = _super.call(this, "FixationComponent", values) || this;
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.fixation_type = undefined;
        _this.fixation_type_state = undefined;
        _this.fixation_type_state_comment = undefined;
        _this.fixation_support_type = undefined;
        _this.fixation_material = undefined;
        _this.fixation_support_type_state = undefined;
        _this.fixation_support_type_state_comment = undefined;
        _this.structure = undefined;
        _this.structure_state = undefined;
        _this.structure_state_comment = undefined;
        _this.material = undefined;
        _this.vertical = undefined;
        _this.state = undefined;
        _this.state_comment = undefined;
        _this.is_conductor = false;
        _this.is_ground = function () { return FixationSupportType.GROUND == _this.fixation_support_type; };
        _this.assets_key = function () { return ["assets"]; };
        _this.from(values);
        return _this;
    }
    FixationComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    FixationComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    FixationComponent.prototype.hasIssuesOrChildrenIssues = function () {
        return this.hasIssues();
    };
    FixationComponent.prototype.getDescriptionKeys = function (is_simulation) {
        var array = [
            "structure",
            "material",
            "structure_state_comment",
            "is_conductor",
            "fixation_type",
            "fixation_material",
            "fixation_type_state_comment",
            "fixation_support_type",
            "fixation_support_type_state",
            "fixation_support_type_state_comment",
        ];
        if (is_simulation)
            return array;
        return __spreadArrays(array, [
            "structure_state",
            "vertical",
            "date",
            "fixation_type_state",
            "has_issues",
            "has_issues_description"
        ]);
    };
    __decorate([
        children(FixationAsset),
        __metadata("design:type", Array)
    ], FixationComponent.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeFixationType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "fixation_type", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "fixation_type_state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "fixation_type_state_comment", void 0);
    __decorate([
        column({ type: TypeText /*TypeFixationType*/, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "fixation_support_type", void 0);
    __decorate([
        column({ type: TypeMaterialSupportType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "fixation_material", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "fixation_support_type_state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "fixation_support_type_state_comment", void 0);
    __decorate([
        column({ type: TypeSupportType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "structure", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "structure_state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "structure_state_comment", void 0);
    __decorate([
        column({ type: TypeMaterialSupportType, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "material", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "vertical", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "state_comment", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], FixationComponent.prototype, "is_conductor", void 0);
    return FixationComponent;
}(Abstract));
export default FixationComponent;
//# sourceMappingURL=FixationComponent.js.map