import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
import { Position } from "../../webservice/Weather";
import IncomingServiceAsset from "./IncomingServiceAsset";
import { ServiceEntrant } from "../helpers/ServiceEntrant";
import { ServiceType } from "../helpers/ServiceType";
import { FailureObject } from "./FailureObject";
export interface IncomingServiceComponentParams extends UUIDable {
    assets: IncomingServiceAsset[];
    name: string | undefined;
    latitudes: string | undefined;
    longitudes: string | undefined;
    comment: string | undefined;
    mode: ServiceEntrant;
    service_type: ServiceType;
}
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
export default class IncomingServiceComponent extends Abstract<IncomingServiceComponentParams, IncomingServiceComponent> implements FailureObject {
    assets: IncomingServiceAsset[];
    hasIssues(): boolean;
    hasIssuesOrChildrenIssues(): boolean;
    validAssets(): IncomingServiceAsset[];
    has_issues: boolean | undefined;
    has_issues_description: string | undefined;
    name: string | undefined;
    latitudes: string | undefined;
    longitudes: string | undefined;
    comment: string | undefined;
    mode: ServiceEntrant;
    service_type: ServiceType;
    constructor(values: IncomingServiceComponentParams);
    verification_keys(): (keyof IncomingServiceComponent)[];
    points(): Position[];
    protected assets_key: () => string[];
    getDescriptionKeys(is_simulation?: boolean): (keyof IncomingServiceComponent)[];
}
