import { Abstract } from "./Abstract";
import ComponentAsset from "./ComponentAsset";
import { Type } from "../helpers/Types";
import { UUIDable } from "../table/UUIDable";
import { CommunicationType } from "./Device";
export interface InstallableComponentParams extends UUIDable {
    date: Date;
    serial_number?: string;
    communicationType?: number;
    description: string;
}
export declare const TypeCommunicationType: Type;
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
export default class InstallableComponent extends Abstract<InstallableComponentParams, InstallableComponent> {
    assets: ComponentAsset[];
    validAssets(): ComponentAsset[];
    serial_number: string | undefined;
    description: string | undefined;
    communicationType: CommunicationType | undefined;
    constructor(values: InstallableComponentParams);
    getCommunicationType(): CommunicationType;
}
