var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Abstract } from "./Abstract";
import ComponentAsset from "./ComponentAsset";
import { RawType, Argument, TypeText } from "../helpers/Types";
import { children, column } from "../helpers/Decorators";
import { CommunicationType } from "./Device";
import { distinctsAbstract } from "../../utils/Array";
var transformFrom = function (value) {
    if (!value)
        return 1;
    switch (value) {
        case 2:
        case CommunicationType.NETWORK_INTERFACE: return 2;
        case 0:
        case CommunicationType.INTELLIGENT: return 0;
        default: return 1;
    }
};
var transformInto = function (value) {
    if (!value)
        return CommunicationType.SIMPLE;
    switch (value) {
        case 2:
        case CommunicationType.NETWORK_INTERFACE: return CommunicationType.NETWORK_INTERFACE;
        case 0:
        case CommunicationType.INTELLIGENT: return CommunicationType.INTELLIGENT;
        default: return CommunicationType.SIMPLE;
    }
};
export var TypeCommunicationType = {
    type: RawType.Integer,
    transformIntoTable: transformFrom,
    transformFromTable: transformInto
};
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var InstallableComponent = /** @class */ (function (_super) {
    __extends(InstallableComponent, _super);
    function InstallableComponent(values) {
        var _this = _super.call(this, "InstallationComponent", values) || this;
        _this.assets = [];
        _this.serial_number = undefined;
        _this.description = undefined;
        _this.communicationType = undefined;
        _this.from(values);
        return _this;
    }
    InstallableComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    InstallableComponent.prototype.getCommunicationType = function () {
        return this.communicationType || CommunicationType.SIMPLE;
    };
    __decorate([
        children(ComponentAsset),
        __metadata("design:type", Array)
    ], InstallableComponent.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], InstallableComponent.prototype, "serial_number", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], InstallableComponent.prototype, "description", void 0);
    __decorate([
        column({ type: TypeCommunicationType, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], InstallableComponent.prototype, "communicationType", void 0);
    return InstallableComponent;
}(Abstract));
export default InstallableComponent;
//# sourceMappingURL=InstallableComponent.js.map