var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Abstract } from "./Abstract";
import InstallableComponent from "./InstallableComponent";
import InstallationAsset from "./InstallationAsset";
import { Argument, TypeInstallationType, TypeText, TypeReal, TypeBoolean } from "../helpers/Types";
import { column, children } from "../helpers/Decorators";
import ParatonnerreComponent from "./ParatonnerreComponent";
import StormDetectorComponent from "./StormDetectorComponent";
import { InstallationType } from "../helpers/InstallationType";
import { InstallationState, TypeInstallationStateType } from "../helpers/InstallationState";
import SurgeArresterComponent from "./SurgeArresterComponent";
import EquipotentialRecoveryComponent from "./EquipotentialRecoveryComponent";
import { distinctsAbstract } from "../../utils/Array";
import { hasIssues } from "./FailureObject";
var Installation = /** @class */ (function (_super) {
    __extends(Installation, _super);
    function Installation(values) {
        var _this = _super.call(this, "Installation", values) || this;
        _this.components = [];
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.name = "";
        _this.address = "";
        _this.description = "";
        _this.building = "";
        _this.latitude = 0;
        _this.longitude = 0;
        _this.paratonnerres = [];
        _this.stormDetectors = [];
        _this.surgeArresters = [];
        _this.equipotentialRecoveries = [];
        _this.mode = InstallationType.PROTECTION;
        //@column({type: TypeProtectionLevel, option: Argument.DefaultNull})
        //public protection_level: ProtectionLevel = ProtectionLevel.UNKNOWN;
        _this.state = InstallationState.INITIAL_DECLARATION;
        _this.assets_key = function () { return ["assets"]; };
        _this.from(values);
        return _this;
    }
    Installation.prototype.validComponents = function () {
        return distinctsAbstract(this.components, true);
    };
    Installation.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    Installation.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    Installation.prototype.hasIssuesOrChildrenIssues = function () {
        if (this.hasIssues())
            return true;
        if (hasIssues(this.validEquipotentialRecoveries()))
            return true;
        if (hasIssues(this.validParatonnerres()))
            return true;
        if (hasIssues(this.validStormDetectors()))
            return true;
        if (hasIssues(this.validSurgeArresters()))
            return true;
        return false;
    };
    Installation.prototype.validParatonnerres = function () {
        return distinctsAbstract(this.paratonnerres, true);
    };
    Installation.prototype.validStormDetectors = function () {
        return distinctsAbstract(this.stormDetectors, true);
    };
    Installation.prototype.validSurgeArresters = function () {
        return distinctsAbstract(this.surgeArresters, true);
    };
    Installation.prototype.validEquipotentialRecoveries = function () {
        return distinctsAbstract(this.equipotentialRecoveries, true);
    };
    Installation.prototype.getState = function () {
        if (!this.state)
            this.state = InstallationState.INITIAL_DECLARATION;
        return TypeInstallationStateType.transformFromTable(this.state);
    };
    Installation.prototype.getType = function () {
        if (!this.mode)
            return InstallationType.PROTECTION;
        switch (this.mode) {
            case InstallationType.DETECTION: return InstallationType.DETECTION;
            case InstallationType.ARRESTER: return InstallationType.ARRESTER;
            default: return InstallationType.PROTECTION;
        }
    };
    Installation.prototype.getDescriptionKeys = function (is_simulation) {
        return [
            "has_issues",
            "has_issues_description"
        ];
    };
    __decorate([
        children(InstallableComponent),
        __metadata("design:type", Array)
    ], Installation.prototype, "components", void 0);
    __decorate([
        children(InstallationAsset),
        __metadata("design:type", Array)
    ], Installation.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], Installation.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], Installation.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Installation.prototype, "name", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Installation.prototype, "address", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Installation.prototype, "description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Installation.prototype, "building", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Installation.prototype, "latitude", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Installation.prototype, "longitude", void 0);
    __decorate([
        children(ParatonnerreComponent),
        __metadata("design:type", Array)
    ], Installation.prototype, "paratonnerres", void 0);
    __decorate([
        children(StormDetectorComponent),
        __metadata("design:type", Array)
    ], Installation.prototype, "stormDetectors", void 0);
    __decorate([
        children(SurgeArresterComponent),
        __metadata("design:type", Array)
    ], Installation.prototype, "surgeArresters", void 0);
    __decorate([
        children(EquipotentialRecoveryComponent),
        __metadata("design:type", Array)
    ], Installation.prototype, "equipotentialRecoveries", void 0);
    __decorate([
        column({ type: TypeInstallationType, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Installation.prototype, "mode", void 0);
    __decorate([
        column({ type: TypeInstallationStateType, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Installation.prototype, "state", void 0);
    return Installation;
}(Abstract));
export default Installation;
//# sourceMappingURL=Installation.js.map