import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
export interface MessageParams extends UUIDable {
    project?: string;
    uuid: string;
    sender: string;
    content?: string;
    additionnal?: string;
    created_at?: number | Date;
    image?: string;
    system: boolean;
    error?: boolean;
    sent?: boolean;
    translation_key?: string;
    additionnal_translation_key?: string;
}
export default class Message extends Abstract<any, Message> implements MessageParams {
    project: string;
    uuid: string;
    created_at?: Date | undefined;
    sender: string;
    content?: string;
    additionnal?: string;
    translation_key?: string;
    additionnal_translation_key?: string;
    local?: boolean;
    image?: string;
    system: boolean;
    error?: boolean;
    sent?: boolean;
    constructor(values: MessageParams);
}
