var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { Abstract } from "./Abstract";
import { TypeText, Argument, TypeInteger, TypeParatonnerreType, TypeReal, TypeBoolean } from "../helpers/Types";
import { children, column } from "../helpers/Decorators";
import { CommunicationType } from "./Device";
import { transformIntoParatonnerreType } from "../helpers/MaterialType";
import ParatonnerreAsset from "./ParatonnerreAsset";
import FixationComponent from "./FixationComponent";
import ConductorComponent from "./ConductorComponent";
import { TypeCommunicationType } from "./InstallableComponent";
import { TypeDeclaredParatonnerreType, DeclaredParatonnerreType } from "../helpers/DeclaredParatonnerreType";
import { TypeStateType } from "../helpers/State";
import { DeclaredRadioactiveParatonnerreType, TypeDeclaredRadioactiveParatonnerreType } from "../helpers/DeclaredRadioactiveParatonnerreType";
import { TypeMaterialLightningRodType, MaterialLightningRodType, transformIntoMaterialLightningRodType } from "../helpers/MaterialLightningRodType";
import { LightningRodType, TypeLightningRodType } from "../helpers/LightningRodType";
import { distinctsAbstract } from "../../utils/Array";
import { hasIssues } from "./FailureObject";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var ParatonnerreComponent = /** @class */ (function (_super) {
    __extends(ParatonnerreComponent, _super);
    function ParatonnerreComponent(values) {
        var _this = _super.call(this, "ParatonnerreComponent", values) || this;
        _this.assets = [];
        _this.fixations = [];
        _this.conductors = [];
        //@children(EquipotentialRecoveryComponent)
        //public equipotential_recoveries: EquipotentialRecoveryComponent[] = [];
        //public validEquipotentialRecoveries() {
        //    return distinctsAbstract(this.equipotential_recoveries, true);
        //}
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.serial_number = "";
        _this.paratonnerre_type = DeclaredParatonnerreType.PARATONNERRE;
        _this.radioactive_type = DeclaredRadioactiveParatonnerreType.UNKNOWN;
        _this.brand = "";
        _this.building_item_uuid = "";
        _this.model = "";
        _this.communicationType = CommunicationType.SIMPLE;
        _this.height = "";
        _this.material = undefined;
        _this.diameter = "";
        _this.description = "";
        _this.height_to_the_protected_structure = 0;
        _this.diameter_to_tip = 0;
        _this.state = 0;
        _this.state_comment = "";
        _this.ahead_to_boot_us = 0;
        _this.physical_connection_state = 0;
        _this.physical_connection_state_comment = "";
        _this.lightning_rod_material_type = MaterialLightningRodType.COPPER;
        _this.lightning_rod_type = LightningRodType.SIMPLE;
        _this.lightning_rod_comment = "";
        _this.will_communicate = false;
        _this.assets_key = function () { return ["assets"]; };
        _this.default_key = "state_comment";
        _this.from(values);
        if (!_this.will_communicate)
            _this.will_communicate = false;
        _this.will_communicate = !!_this.will_communicate;
        return _this;
    }
    ParatonnerreComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    ParatonnerreComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    ParatonnerreComponent.prototype.hasIssuesOrChildrenIssues = function () {
        if (this.hasIssues())
            return true;
        if (hasIssues(this.validConductors()))
            return true;
        if (hasIssues(this.validFixations()))
            return true;
        return false;
    };
    ParatonnerreComponent.prototype.validFixations = function () {
        return distinctsAbstract(this.fixations, true);
    };
    ParatonnerreComponent.prototype.validConductors = function () {
        return distinctsAbstract(this.conductors, true);
    };
    ParatonnerreComponent.prototype.keys = function () {
        return [
            "assets",
            "fixations",
            "conductors",
            //"equipotential_recoveries",
            "serial_number",
            "paratonnerre_type",
            "radioactive_type",
            "brand",
            "building_item_uuid",
            "model",
            "communicationType",
            "height",
            "material",
            "diameter",
            "description",
            "height_to_the_protected_structure",
            "diameter_to_tip",
            "state",
            "state_comment",
            "ahead_to_boot_us",
            "physical_connection_state",
            "physical_connection_state_comment",
            "lightning_rod_material_type",
            "lightning_rod_type",
            "lightning_rod_comment",
            "will_communicate",
            "has_issues",
            "has_issues_description"
        ];
    };
    ParatonnerreComponent.prototype.verification_keys = function () {
        var keys = this.specificVerificationKeys();
        var returning_keys = this.annotated_columns().filter(function (c) { return c.value.in_verification; }).map(function (c) { return c.key; });
        var merged = [];
        [returning_keys, keys].forEach(function (a) { return a.forEach(function (k) { return !merged.includes(k) && merged.push(k); }); });
        merged.forEach(function (key) {
            if (!keys.includes(key))
                console.log("invalid merged key, not known in specificVerificationKeys !!! " + key);
            if (!returning_keys.includes(key))
                console.log("invalid merged key, not known in annotated_columns !!! " + key);
        });
        return merged;
    };
    ParatonnerreComponent.prototype.specificVerificationKeys = function () {
        switch (this.paratonnerre_type) {
            case DeclaredParatonnerreType.PDA:
                return [
                    "building_item_uuid",
                    "brand",
                    "model",
                    "serial_number",
                    "ahead_to_boot_us",
                    "height_to_the_protected_structure",
                    "state",
                    "state_comment",
                    "physical_connection_state",
                    "physical_connection_state_comment",
                    "date"
                ];
            case DeclaredParatonnerreType.PARATONNERRE:
                return [
                    "building_item_uuid",
                    "material",
                    "lightning_rod_type",
                    "lightning_rod_comment",
                    "height_to_the_protected_structure",
                    "diameter_to_tip",
                    "state",
                    "state_comment",
                    "physical_connection_state",
                    "physical_connection_state_comment",
                    "date",
                    "description"
                ];
            case DeclaredParatonnerreType.RADIOACTIVE:
                return [
                //TODO ?
                ];
            default:
                return [
                    "building_item_uuid",
                    "lightning_rod_comment",
                    "height_to_the_protected_structure",
                    //"diameter_to_tip", -> in unknown, unnecessary
                    "state",
                    "state_comment",
                    "date",
                    "description",
                    "physical_connection_state",
                    "physical_connection_state_comment"
                ];
        }
    };
    ParatonnerreComponent.prototype.getAsPDA = function () {
        return {
            building_item_uuid: this.building_item_uuid,
            brand: this.brand,
            model: this.model,
            serial_number: this.serial_number,
            ahead_to_boot_us: this.ahead_to_boot_us,
            height_to_the_protected_structure: this.height_to_the_protected_structure || 0,
            state: TypeStateType.transformFromTable(this.state),
            state_comment: this.state_comment,
            date: this.date,
            physical_connection_state: this.physical_connection_state,
            physical_connection_state_comment: this.physical_connection_state_comment,
            assets: this.validAssets() || [],
            fixations: this.validFixations() || [],
            conductors: this.validConductors() || [],
            description: this.description,
            has_issues: !!this.hasIssues(),
            has_issues_description: this.has_issues_description,
        };
    };
    ParatonnerreComponent.prototype.getAsUnknown = function () {
        return {
            building_item_uuid: this.building_item_uuid,
            height_to_the_protected_structure: this.height_to_the_protected_structure || 0,
            diameter_to_tip: this.diameter_to_tip || 0,
            state: TypeStateType.transformFromTable(this.state),
            state_comment: this.state_comment,
            lightning_rod_comment: this.lightning_rod_comment,
            date: this.date,
            physical_connection_state: this.physical_connection_state,
            physical_connection_state_comment: this.physical_connection_state_comment,
            assets: this.validAssets() || [],
            fixations: this.validFixations() || [],
            conductors: this.validConductors() || [],
            description: this.description,
            has_issues: !!this.hasIssues(),
            has_issues_description: this.has_issues_description,
        };
    };
    ParatonnerreComponent.prototype.getAsSimpleParatonnerre = function () {
        return {
            building_item_uuid: this.building_item_uuid,
            material: transformIntoParatonnerreType(this.material),
            height_to_the_protected_structure: parseInt("" + this.height_to_the_protected_structure),
            diameter_to_tip: this.diameter_to_tip || 0,
            state: TypeStateType.transformFromTable(this.state),
            state_comment: this.state_comment,
            lightning_rod_material_type: transformIntoMaterialLightningRodType(this.lightning_rod_material_type),
            lightning_rod_comment: this.lightning_rod_comment,
            lightning_rod_type: this.lightning_rod_type || LightningRodType.SIMPLE,
            date: this.date,
            physical_connection_state: this.physical_connection_state,
            physical_connection_state_comment: this.physical_connection_state_comment,
            assets: this.validAssets() || [],
            fixations: this.validFixations() || [],
            conductors: this.validConductors() || [],
            description: this.description,
            has_issues: !!this.hasIssues(),
            has_issues_description: this.has_issues_description,
        };
    };
    ParatonnerreComponent.prototype.getCommunicationType = function () {
        return this.communicationType || CommunicationType.SIMPLE;
    };
    ParatonnerreComponent.prototype.getDescriptionKeys = function (is_simulation) {
        var declared = this.paratonnerre_type || DeclaredParatonnerreType.UNKNOWN;
        switch (declared) {
            case DeclaredParatonnerreType.UNKNOWN:
                var values = [
                    "lightning_rod_comment",
                    "height_to_the_protected_structure",
                    "diameter_to_tip",
                    "state_comment",
                    "building_item_uuid",
                    this.default_key
                ];
                if (is_simulation) {
                    return values;
                }
                return __spreadArrays(values, [
                    "has_issues",
                    "has_issues_description",
                    "physical_connection_state",
                    "physical_connection_state_comment",
                ]);
            case DeclaredParatonnerreType.PDA:
                var pda = [
                    this.default_key,
                    "ahead_to_boot_us",
                    "height_to_the_protected_structure",
                    "building_item_uuid"
                ];
                if (!is_simulation) {
                    pda = __spreadArrays(pda, ["brand",
                        "model",
                        "serial_number",
                        "physical_connection_state",
                        "physical_connection_state_comment",
                        "has_issues",
                        "has_issues_description"]);
                }
                return pda;
            //case DeclaredParatonnerreType.PARATONNERRE:
            default:
                var array = [
                    "lightning_rod_comment",
                    "lightning_rod_material_type",
                    "lightning_rod_type",
                    "material",
                    "height_to_the_protected_structure",
                    "diameter_to_tip",
                    "state_comment",
                    "physical_connection_state",
                    "physical_connection_state_comment",
                    "building_item_uuid",
                    this.default_key
                ];
                if (!!is_simulation)
                    return array;
                return __spreadArrays(array, ["has_issues", "has_issues_description"]);
        }
    };
    __decorate([
        children(ParatonnerreAsset),
        __metadata("design:type", Array)
    ], ParatonnerreComponent.prototype, "assets", void 0);
    __decorate([
        children(FixationComponent),
        __metadata("design:type", Array)
    ], ParatonnerreComponent.prototype, "fixations", void 0);
    __decorate([
        children(ConductorComponent),
        __metadata("design:type", Array)
    ], ParatonnerreComponent.prototype, "conductors", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "serial_number", void 0);
    __decorate([
        column({ type: TypeDeclaredParatonnerreType, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], ParatonnerreComponent.prototype, "paratonnerre_type", void 0);
    __decorate([
        column({ type: TypeDeclaredRadioactiveParatonnerreType, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], ParatonnerreComponent.prototype, "radioactive_type", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "brand", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "building_item_uuid", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "model", void 0);
    __decorate([
        column({ type: TypeCommunicationType, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], ParatonnerreComponent.prototype, "communicationType", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "height", void 0);
    __decorate([
        column({ type: TypeParatonnerreType, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "material", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "diameter", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "description", void 0);
    __decorate([
        column({ type: TypeInteger, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "height_to_the_protected_structure", void 0);
    __decorate([
        column({ type: TypeInteger, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "diameter_to_tip", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "state_comment", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], ParatonnerreComponent.prototype, "ahead_to_boot_us", void 0);
    __decorate([
        column({ type: TypeStateType, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "physical_connection_state", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "physical_connection_state_comment", void 0);
    __decorate([
        column({ type: TypeMaterialLightningRodType, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "lightning_rod_material_type", void 0);
    __decorate([
        column({ type: TypeLightningRodType, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "lightning_rod_type", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], ParatonnerreComponent.prototype, "lightning_rod_comment", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], ParatonnerreComponent.prototype, "will_communicate", void 0);
    return ParatonnerreComponent;
}(Abstract));
export default ParatonnerreComponent;
//# sourceMappingURL=ParatonnerreComponent.js.map