var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Abstract } from "./Abstract";
import Installation from "./Installation";
import { column, children } from "../helpers/Decorators";
import ProjectAsset from "./ProjectAsset";
import { TypeText, Argument, TypeReal, TypeBoolean, TypeDate, TypeInteger } from "../helpers/Types";
import { TypeMaintenanceInterval, MaintenanceInterval } from "../helpers/MaintenanceInterval";
import { InstallationState } from "../helpers/InstallationState";
import Building from "./Building";
import Bridge from "./Bridge";
import { TypeProtectionLevel, ProtectionLevel } from "../helpers/ProtectionLevel";
import { distinctsAbstract } from "../../utils/Array";
import { hasIssues } from "./FailureObject";
var Verification = /** @class */ (function (_super) {
    __extends(Verification, _super);
    function Verification(values) {
        var _this = _super.call(this, "ProjectVerification", values) || this;
        // this is set right below to prevent circle dependency
        _this.projects = [];
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.user = "";
        _this.validated = false;
        _this.validated_date = undefined;
        _this.started_at_optional = undefined;
        _this.validated_text = undefined;
        _this.is_simulation = undefined;
        _this.populate = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.populate.call(this)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.populateChildrenForKey("projects", Project)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this];
                }
            });
        }); };
        _this.from(values);
        return _this;
    }
    Verification.prototype.validProjects = function () {
        if (!this.projects)
            return [];
        return distinctsAbstract(this.projects, true);
    };
    Verification.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    Verification.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    Verification.prototype.hasIssuesOrChildrenIssues = function () {
        if (this.hasIssues())
            return true;
        if (hasIssues(this.validProjects()))
            return true;
        return false;
    };
    Verification.prototype.full_json = function (include_local, exclude_assets) {
        var json = _super.prototype.full_json.call(this, include_local, exclude_assets);
        json.projects = this.projects.map(function (p) { return p.full_json(include_local, exclude_assets); });
        return json;
    };
    Verification.prototype.save = function (recursive) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.save.call(this, recursive)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(this.projects.map(function (p) {
                                p.parent_id = _this.id;
                                return p.save(recursive);
                            }))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this];
                }
            });
        });
    };
    Verification.prototype.project = function () {
        var _this = this;
        var array = this.validProjects();
        array.forEach(function (a) { return a.setSimulation(!!_this.is_simulation); });
        return array.length > 0 ? array[0] : null;
    };
    Verification.prototype.init = function (instance) {
        this.descriptor = _super.prototype.init.call(this, instance);
        if (!this.descriptor.child("projects")) {
            console.warn("fixing missing dependency for projects in Verification");
            this.descriptor.addColumnChild("projects", Project);
        }
        else {
            console.warn("no need to fix the projects for Verification");
        }
        return this.descriptor;
    };
    Verification.prototype.annotated_children = function () {
        var children = _super.prototype.annotated_children.call(this);
        //it will edit and modify if required
        var contains_verification = children.find(function (holder) { return holder.key === "projects"; });
        if (!contains_verification) {
            children.push({ key: "projects", value: Project });
        }
        return children;
    };
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], Verification.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], Verification.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Verification.prototype, "user", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Verification.prototype, "validated", void 0);
    __decorate([
        column({ type: TypeDate, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Verification.prototype, "validated_date", void 0);
    __decorate([
        column({ type: TypeDate, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Verification.prototype, "started_at_optional", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Verification.prototype, "validated_text", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Verification.prototype, "is_simulation", void 0);
    return Verification;
}(Abstract));
export { Verification };
var Project = /** @class */ (function (_super) {
    __extends(Project, _super);
    function Project(values) {
        var _this = _super.call(this, "Project", values) || this;
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.maintenance_interval = MaintenanceInterval.YEAR_1;
        _this.name = "";
        _this.address = "";
        _this.description = "";
        _this.longitude = 0;
        _this.latitude = 0;
        _this.countryCode = "";
        _this.adminArea = "";
        _this.to_sync = false;
        _this.last_message_server = undefined;
        _this.registered_devices = "";
        _this.local_user_id = undefined;
        _this.contact_name = "";
        _this.contact_email = "";
        _this.contact_status = "";
        _this.contact_phone = "";
        _this.delta_latitude_meter = 0;
        _this.delta_longitude_meter = 0;
        _this.buildings = [];
        _this.bridges = [];
        _this.installations = [];
        _this.verifications = [];
        _this.assets = [];
        _this.protection_level = ProtectionLevel.UNKNOWN;
        _this.language = "en";
        _this.assets_key = function () { return ["assets"]; };
        _this.is_simulation = false;
        _this.populate = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.populate.call(this)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.populateChildrenForKey("verifications", Verification)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this];
                }
            });
        }); };
        _this.from(values);
        _this.checkPush();
        return _this;
    }
    Project.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    Project.prototype.hasIssuesOrChildrenIssues = function () {
        if (this.hasIssues())
            return true;
        if (hasIssues(this.validSimulations()))
            return true;
        if (hasIssues(this.validInstallations()))
            return true;
        if (hasIssues(this.validVerifications()))
            return true;
        return false;
    };
    Project.prototype.validBuildings = function () {
        return distinctsAbstract(this.buildings, true);
    };
    Project.prototype.validBridges = function () {
        return distinctsAbstract(this.bridges, true);
    };
    Project.prototype.validInstallations = function () {
        return distinctsAbstract(this.installations, true);
    };
    Project.prototype.validVerifications = function () {
        return distinctsAbstract(this.verifications, true)
            .filter(function (v) { return !v.is_simulation; });
    };
    Project.prototype.validSimulations = function () {
        return distinctsAbstract(this.verifications, true)
            .filter(function (v) { return !!v.is_simulation; });
    };
    Project.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    Project.prototype.lang = function () {
        if (!!this.language && ["en", "fr", "es", "pt"].includes(this.language))
            return this.language; //force valid, but it's already set
        return "en";
    };
    Project.prototype.checkPush = function () {
        var _this = this;
        //by default make the value to something useful
        [["push_notification_start_at", 8], ["push_notification_stop_at", 20]].forEach(function (k) {
            if (null == _this[k[0]] || undefined == _this[k[0]]) {
                _this[k[0]] = k[1];
            }
        });
    };
    Project.prototype.valid_devices = function () {
        return (this.registered_devices || "").split(",");
    };
    Project.prototype.calculate_protection_level = function (ng) {
        if (this.protection_level)
            return this.protection_level;
        var protection = ProtectionLevel.UNKNOWN;
        this.validBuildings().forEach(function (building) {
            var new_protection = building.getTheoricalProtectionLevel(ng);
            if (!new_protection)
                return;
            if (new_protection == ProtectionLevel.LEVEL_1_PLUS || new_protection == ProtectionLevel.LEVEL_1_PLUS_PLUS) {
                if (protection == ProtectionLevel.UNKNOWN || protection == ProtectionLevel.LEVEL_1) {
                    protection = new_protection;
                }
                else if (protection == ProtectionLevel.LEVEL_1_PLUS && new_protection == ProtectionLevel.LEVEL_1_PLUS_PLUS) {
                    protection = new_protection;
                }
            }
            else if (new_protection > protection) {
                //when we don't have any 1+ or 1++
                protection = new_protection;
            }
        });
        return ProtectionLevel.UNKNOWN;
    };
    Project.prototype.state = function () {
        if (!this.installations)
            this.installations = [];
        var state = InstallationState.VERIFIED;
        this.validInstallations().forEach(function (installation) {
            var local = installation.state || InstallationState.INITIAL_DECLARATION;
            switch (local) {
                case InstallationState.PENDING_VERIFICATION: {
                    if (state == InstallationState.VERIFIED)
                        state = InstallationState.PENDING_VERIFICATION;
                }
                case InstallationState.WAITING_FOR_VERIFICATION: {
                    if (state == InstallationState.VERIFIED || state == InstallationState.PENDING_VERIFICATION) {
                        state = InstallationState.WAITING_FOR_VERIFICATION;
                    }
                }
                case InstallationState.INITIAL_DECLARATION: {
                    state = InstallationState.INITIAL_DECLARATION;
                }
                default: { }
            }
        });
        var verifications = this.validVerifications();
        if (verifications.length > 0) {
            verifications.forEach(function (verification) {
                if (!verification.deleted) {
                    if (verification.validated || verification.optional_verification_validated) {
                        if (state != InstallationState.PENDING_VERIFICATION) {
                            state = InstallationState.VERIFIED;
                        }
                    }
                    if (!verification.validated && !verification.optional_verification_validated) {
                        state = InstallationState.PENDING_VERIFICATION;
                    }
                }
            });
        }
        return state;
    };
    Project.prototype.clone = function () {
        var json = _super.prototype.clone.call(this);
        if (json) {
            json.verifications = undefined;
            json.registered_devices = undefined;
        }
        return json;
    };
    Project.prototype.setSimulation = function (is_simulation) {
        this.is_simulation = !!is_simulation;
    };
    Project.prototype.isSimulation = function () {
        return this.is_simulation;
    };
    Project.prototype.init = function (instance) {
        this.descriptor = _super.prototype.init.call(this, instance);
        if (!this.descriptor.child("verifications")) {
            console.warn("fixing missing dependency for verifications in project");
            this.descriptor.addColumnChild("verifications", Verification);
        }
        else {
            console.warn("no need to fix the dependency regarding verifications in Project");
        }
        return this.descriptor;
    };
    Project.prototype.annotated_columns = function () {
        var columns = _super.prototype.annotated_columns.call(this);
        return columns;
    };
    Project.prototype.annotated_children = function () {
        var children = _super.prototype.annotated_children.call(this);
        //it will edit and modify if required
        var contains_verification = children.find(function (holder) { return holder.key === "verifications"; });
        if (!contains_verification) {
            console.warn("add way to build verifications from Project");
            children.push({ key: "verifications", value: Verification });
        }
        var keys = [];
        children.forEach(function (_a) {
            var key = _a.key;
            return (!keys.includes(key)) && (keys.push(key));
        });
        var final_children = keys.map(function (k) { return children.find(function (holder) { return holder.key == k; }); });
        return final_children;
    };
    Project.prototype.setDelta = function (latitude, longitude) {
        this.delta_latitude_meter = latitude;
        this.delta_longitude_meter = longitude;
    };
    Project.prototype.deltaMeter = function () {
        return {
            latitude: this.delta_latitude_meter,
            longitude: this.delta_longitude_meter
        };
    };
    Project.prototype.deltaKm = function () {
        if (!this.delta_latitude_meter && !this.delta_longitude_meter)
            return {
                latitude: 0,
                longitude: 0
            };
        return {
            latitude: this.delta_latitude_meter * 1. / 1000,
            longitude: this.delta_longitude_meter * 1. / 1000
        };
    };
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Project.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Project.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeMaintenanceInterval, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "maintenance_interval", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "name", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "address", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "description", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Project.prototype, "longitude", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Project.prototype, "latitude", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "countryCode", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "adminArea", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull }),
        __metadata("design:type", Boolean)
    ], Project.prototype, "to_sync", void 0);
    __decorate([
        column({ type: TypeDate, option: Argument.DefaultNull, local_only: true }),
        __metadata("design:type", Object)
    ], Project.prototype, "last_message_server", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Object)
    ], Project.prototype, "registered_devices", void 0);
    __decorate([
        column({ type: TypeInteger, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Project.prototype, "push_notification_start_at", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Project.prototype, "push_notification_stop_at", void 0);
    __decorate([
        column({ type: TypeInteger, option: Argument.DefaultNull, local_only: true }),
        __metadata("design:type", Number)
    ], Project.prototype, "local_user_id", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "contact_name", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "contact_email", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "contact_status", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "contact_phone", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Project.prototype, "delta_latitude_meter", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Project.prototype, "delta_longitude_meter", void 0);
    __decorate([
        children(Building),
        __metadata("design:type", Array)
    ], Project.prototype, "buildings", void 0);
    __decorate([
        children(Bridge),
        __metadata("design:type", Array)
    ], Project.prototype, "bridges", void 0);
    __decorate([
        children(Installation),
        __metadata("design:type", Array)
    ], Project.prototype, "installations", void 0);
    __decorate([
        children(Verification),
        __metadata("design:type", Array)
    ], Project.prototype, "verifications", void 0);
    __decorate([
        children(ProjectAsset),
        __metadata("design:type", Array)
    ], Project.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeProtectionLevel, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], Project.prototype, "protection_level", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull }),
        __metadata("design:type", String)
    ], Project.prototype, "language", void 0);
    return Project;
}(Abstract));
export { Project };
//# sourceMappingURL=ProjectVerification.js.map