import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
import StormDetectorAsset from "./StormDetectorAsset";
import { FailureObject, FailureObjectFields } from "./FailureObject";
export interface StormDetectorComponentParams extends UUIDable, FailureObjectFields {
    date: Date;
    serial_number?: string;
    description: string;
}
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
export default class StormDetectorComponent extends Abstract<StormDetectorComponentParams, StormDetectorComponent> implements FailureObject {
    assets: StormDetectorAsset[];
    validAssets(): StormDetectorAsset[];
    hasIssues(): boolean;
    hasIssuesOrChildrenIssues(): boolean;
    has_issues: boolean | undefined;
    has_issues_description: string | undefined;
    serial_number: string | undefined;
    description: string | undefined;
    will_communicate: boolean | undefined;
    constructor(values: StormDetectorComponentParams);
    protected assets_key: () => string[];
    getDescriptionKeys(is_simulation?: boolean): (keyof StormDetectorComponent)[];
}
