var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Abstract } from "./Abstract";
import { children, column } from "../helpers/Decorators";
import StormDetectorAsset from "./StormDetectorAsset";
import { Argument, TypeBoolean, TypeText } from "../helpers/Types";
import { distinctsAbstract } from "../../utils/Array";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var StormDetectorComponent = /** @class */ (function (_super) {
    __extends(StormDetectorComponent, _super);
    function StormDetectorComponent(values) {
        var _this = _super.call(this, "StormDetectorComponent", values) || this;
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.serial_number = "";
        _this.description = "";
        _this.will_communicate = false;
        _this.assets_key = function () { return ["assets"]; };
        _this.from(values);
        if (!_this.will_communicate)
            _this.will_communicate = false;
        _this.will_communicate = !!_this.will_communicate;
        return _this;
    }
    StormDetectorComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    StormDetectorComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    StormDetectorComponent.prototype.hasIssuesOrChildrenIssues = function () {
        return this.hasIssues();
    };
    StormDetectorComponent.prototype.getDescriptionKeys = function (is_simulation) {
        return [
            "has_issues",
            "has_issues_description",
            "serial_number",
        ];
    };
    __decorate([
        children(StormDetectorAsset),
        __metadata("design:type", Array)
    ], StormDetectorComponent.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], StormDetectorComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], StormDetectorComponent.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], StormDetectorComponent.prototype, "serial_number", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], StormDetectorComponent.prototype, "description", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], StormDetectorComponent.prototype, "will_communicate", void 0);
    return StormDetectorComponent;
}(Abstract));
export default StormDetectorComponent;
//# sourceMappingURL=StormDetectorComponent.js.map