import { Abstract } from "./Abstract";
import { UUIDable } from "../table/UUIDable";
import SurgeArresterAsset from "./SurgeArresterAsset";
import { FailureObject, FailureObjectFields } from "./FailureObject";
export interface SurgeArresterComponentParams extends UUIDable, FailureObjectFields {
    date: Date;
    serial_number?: string;
    brand?: string;
    model?: string;
    still_functionnal?: string;
    description: string;
    position_on_network?: string;
    visible_type?: string;
    Uc?: number;
    Imax?: number;
    Up?: number;
    pole_number?: number;
}
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
export default class SurgeArresterComponent extends Abstract<SurgeArresterComponentParams, SurgeArresterComponent> implements FailureObject {
    assets: SurgeArresterAsset[];
    validAssets(): SurgeArresterAsset[];
    hasIssues(): boolean;
    hasIssuesOrChildrenIssues(): boolean;
    has_issues: boolean | undefined;
    has_issues_description: string | undefined;
    serial_number: string | undefined;
    brand: string | undefined;
    neutral_earthing_system: string | undefined;
    model: string | undefined;
    still_functionnal: boolean | undefined;
    description: string | undefined;
    position_on_network: string | undefined;
    visible_type: string | undefined;
    state_comment: string | undefined;
    latitude: number;
    longitude: number;
    Uc: number | undefined;
    Imax: number | undefined;
    Up: number | undefined;
    pole_number: number | undefined;
    will_communicate: boolean | undefined;
    constructor(values: SurgeArresterComponentParams);
    protected assets_key: () => string[];
    getDescriptionKeys(is_simulation?: boolean): (keyof SurgeArresterComponent)[];
}
