var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { Abstract } from "./Abstract";
import { children, column } from "../helpers/Decorators";
import SurgeArresterAsset from "./SurgeArresterAsset";
import { Argument, TypeBoolean, TypeReal, TypeText } from "../helpers/Types";
import { distinctsAbstract } from "../../utils/Array";
/**
 * The Component class will be a device for instance
 *   lpsfr uuid
 *   description
 *   etc...
 */
var SurgeArresterComponent = /** @class */ (function (_super) {
    __extends(SurgeArresterComponent, _super);
    function SurgeArresterComponent(values) {
        var _this = _super.call(this, "SurgeArresterComponent", values) || this;
        _this.assets = [];
        _this.has_issues = false;
        _this.has_issues_description = "";
        _this.serial_number = "";
        _this.brand = "";
        _this.neutral_earthing_system = "";
        _this.model = "";
        _this.still_functionnal = false;
        _this.description = "";
        _this.position_on_network = "";
        _this.visible_type = "";
        _this.state_comment = ""; //for below values
        _this.latitude = 0;
        _this.longitude = 0;
        _this.Uc = 0;
        _this.Imax = 0;
        _this.Up = 0;
        _this.pole_number = 0;
        _this.will_communicate = false;
        _this.assets_key = function () { return ["assets"]; };
        _this.from(values);
        if (!_this.will_communicate)
            _this.will_communicate = false;
        _this.will_communicate = !!_this.will_communicate;
        return _this;
    }
    SurgeArresterComponent.prototype.validAssets = function () {
        return distinctsAbstract(this.assets);
    };
    SurgeArresterComponent.prototype.hasIssues = function () {
        return !!this.has_issues;
    };
    SurgeArresterComponent.prototype.hasIssuesOrChildrenIssues = function () {
        return this.hasIssues();
    };
    SurgeArresterComponent.prototype.getDescriptionKeys = function (is_simulation) {
        var array = [
            "position_on_network",
            "description",
            "neutral_earthing_system",
            "visible_type",
            "pole_number"
        ];
        if (is_simulation)
            return array;
        return __spreadArrays(array, [
            "has_issues",
            "has_issues_description",
            "serial_number",
            "brand",
            "model",
            "still_functionnal"
        ]);
    };
    __decorate([
        children(SurgeArresterAsset),
        __metadata("design:type", Array)
    ], SurgeArresterComponent.prototype, "assets", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "has_issues", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "has_issues_description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "serial_number", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "brand", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "neutral_earthing_system", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "model", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "still_functionnal", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "description", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "position_on_network", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "visible_type", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "state_comment", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], SurgeArresterComponent.prototype, "latitude", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull }),
        __metadata("design:type", Number)
    ], SurgeArresterComponent.prototype, "longitude", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "Uc", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "Imax", void 0);
    __decorate([
        column({ type: TypeReal, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "Up", void 0);
    __decorate([
        column({ type: TypeText, option: Argument.DefaultNull, in_verification: true }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "pole_number", void 0);
    __decorate([
        column({ type: TypeBoolean, option: Argument.DefaultNull, in_verification: false }),
        __metadata("design:type", Object)
    ], SurgeArresterComponent.prototype, "will_communicate", void 0);
    return SurgeArresterComponent;
}(Abstract));
export default SurgeArresterComponent;
//# sourceMappingURL=SurgeArresterComponent.js.map