import { EventEmitter2 } from "eventemitter2";
export default class User extends EventEmitter2 {
    id: number;
    private _guid;
    private _login;
    private _email;
    private _persistence_token?;
    private _rights;
    private _company;
    private _address;
    private _city;
    private _lastname;
    private _surname;
    private _firstname;
    private _postalcode;
    private _state;
    private _website;
    private _phone;
    private _vault_size;
    private _gems;
    private _lightning_radius;
    private _lightning_notification_type;
    constructor(id: number, guid: string, login: string, email: string, persistence_token: string | undefined, rights: string, company: string, address: string, city: string, firstname: string, lastname: string, surname: string, postalcode: string, state: string, website: string, phone: string, vault_size: number, gems: number, lightning_radius: number, lightning_notification_type: string);
    uuid: () => string;
    phone: () => string;
    login: () => string;
    email: () => string;
    token: () => string | undefined;
    rights: () => string[];
    company: () => string;
    address: () => string;
    city: () => string;
    firstname: () => string;
    lastname: () => string;
    surname: () => string;
    postalcode: () => string;
    state: () => string;
    website: () => string;
    vault_size(): number;
    gems(): number;
    lightning_radius(): number;
    lightning_notification_type(): string;
    setLightningRadius: (lightning_radius: number) => User;
    setLightningNotificationType: (lightning_notification_type: string) => User;
    setUuid: (uuid: string) => User;
    setPhone: (phone: string) => User;
    setRights: (rights: string[]) => User;
    setVaultSize: (vault_size: number) => User;
    setGems: (gems: number) => User;
    setLogin: (login: string) => this;
    setEmail: (email: string) => this;
    setToken: (token: string) => this;
    setCompany: (company: string) => this;
    setAddress: (address: string) => this;
    setCity: (city: string) => this;
    setLastname: (lastname: string) => this;
    setSurname: (surname: string) => this;
    setFirstname: (firstname: string) => this;
    setPostalcode: (postalcode: string) => this;
    setState: (state: string) => this;
    setWebsite: (website: string) => this;
    subscriptions: () => never[];
    hasValidSubscriptions: () => boolean;
}
