import { ColumnAnnotation } from "../helpers/Types";
import Column from "../helpers/Column";
export interface BindTogether<TYPE> {
    key: string;
    value: TYPE;
}
export default class DbDescriptor {
    name: string;
    columns: Column[];
    private simple_columns_array;
    private children_columns_array;
    constructor(name: string);
    add(name: string, type: ColumnAnnotation): this;
    child: (name: string) => BindTogether<any> | undefined;
    column: (name: string) => BindTogether<ColumnAnnotation> | undefined;
    annotated_children: () => BindTogether<any>[];
    annotated_columns: () => BindTogether<ColumnAnnotation>[];
    addColumnAnnotation(key: string, value: ColumnAnnotation): void;
    addColumnChild(key: string, value: any): void;
    toString(): string;
    migration(): string[];
}
