import Column from "../helpers/Column";
var DbDescriptor = /** @class */ (function () {
    function DbDescriptor(name) {
        var _this = this;
        this.name = name;
        this.columns = [];
        this.simple_columns_array = [];
        this.children_columns_array = [];
        this.child = function (name) { return _this.children_columns_array.find(function (c) { return c.key == name; }); };
        this.column = function (name) { return _this.simple_columns_array.find(function (c) { return c.key == name; }); };
        this.annotated_children = function () { return _this.children_columns_array; };
        this.annotated_columns = function () { return _this.simple_columns_array; };
    }
    DbDescriptor.prototype.add = function (name, type) {
        this.columns.push(new Column(name).fromDecorator(type));
        return this;
    };
    DbDescriptor.prototype.addColumnAnnotation = function (key, value) {
        this.simple_columns_array.push({ key: key, value: value });
    };
    DbDescriptor.prototype.addColumnChild = function (key, value) {
        this.children_columns_array.push({ key: key, value: value });
    };
    DbDescriptor.prototype.toString = function () {
        var columns = this.columns.map(function (c) { return c.toString(); });
        var indexes = this.columns.filter(function (c) { return c.isIndex(); }).map(function (c) { return "INDEX " + c.createIndex(); });
        //const genned: string = [ ...columns, ...indexes].join(", ");
        var genned = columns.join(", ");
        return "CREATE TABLE IF NOT EXISTS " + this.name + " (" + genned + ");";
    };
    DbDescriptor.prototype.migration = function () {
        var _this = this;
        var queries = [];
        this.columns.forEach(function (column) { return queries.push("ALTER TABLE " + _this.name + " ADD COLUMN " + column.migrate()); });
        return queries;
    };
    return DbDescriptor;
}());
export default DbDescriptor;
//# sourceMappingURL=DbDescriptor.js.map