import Api from "./webservice/Api";
import ConfigManager from "./managers/ConfigManager";
import ProjectDatabase from "./managers/ProjectDatabase";
import { Device, User, DefaultAssetParams } from "./db/models/";
import DBCache from "./db/helpers/DBCache";
import Logger from "./managers/Logger";
import { ConductorAsset, ConductorComponent, FixationAsset, FixationComponent, GroundingAsset, GroundingComponent, ElectricalGroundingAsset, ElectricalGroundingComponent, IncomingServiceAsset, IncomingServiceComponent, ParatonnerreAsset, ParatonnerreComponent, StormDetectorAsset, StormDetectorComponent, ProjectAsset, Project, InstallableComponent, InstallableComponentParams, InstallationAsset, Installation, ComponentAsset, InstallationParams, ProjectInterface, CounterAsset, CounterComponent } from "./db/models";
declare const Models: {
    Device: typeof Device;
    User: typeof User;
};
declare const ModelsV2: {
    InstallableComponent: typeof InstallableComponent;
    ComponentAsset: typeof ComponentAsset;
    Installation: typeof Installation;
    InstallationAsset: typeof InstallationAsset;
    Project: typeof Project;
    ProjectAsset: typeof ProjectAsset;
    ConductorAsset: typeof ConductorAsset;
    ConductorComponent: typeof ConductorComponent;
    FixationAsset: typeof FixationAsset;
    FixationComponent: typeof FixationComponent;
    GroundingAsset: typeof GroundingAsset;
    GroundingComponent: typeof GroundingComponent;
    ElectricalGroundingAsset: typeof ElectricalGroundingAsset;
    ElectricalGroundingComponent: typeof ElectricalGroundingComponent;
    IncomingServiceAsset: typeof IncomingServiceAsset;
    IncomingServiceComponent: typeof IncomingServiceComponent;
    ParatonnerreAsset: typeof ParatonnerreAsset;
    ParatonnerreComponent: typeof ParatonnerreComponent;
    StormDetectorAsset: typeof StormDetectorAsset;
    StormDetectorComponent: typeof StormDetectorComponent;
    CounterAsset: typeof CounterAsset;
    CounterComponent: typeof CounterComponent;
};
export { Logger, Api, Models, ModelsV2, ConfigManager, ProjectDatabase, DBCache, InstallableComponentParams, DefaultAssetParams, InstallationParams, ProjectInterface };
