import SQLite, { Transaction } from "react-native-sqlite-storage";
import { User, Device, Routair, DeviceLog } from "../db/models";
import LocalDevice from "./LocalDevice";
export default class ConfigManager {
    onBoarding: boolean | null;
    _db?: SQLite.SQLiteDatabase;
    _opened: boolean;
    _users: User[];
    _list_users: User[];
    _users_by_id: User[];
    _users_by_persistence_token: User[];
    _devices: Device[];
    _devices_contactair: Device[];
    _known_contactair: never[];
    constructor();
    init(): Promise<void>;
    private _openDatabase;
    private openCallback;
    transaction(): Promise<Transaction | undefined>;
    private _executeSql;
    private _queryTransaction;
    queryTransaction(tx: Transaction, query: string, params?: any[], skipFailure?: boolean): Promise<SQLite.ResultSet | undefined>;
    query(query: string, params?: any[]): Promise<SQLite.ResultSet | undefined>;
    private _query;
    logout(): Promise<any>;
    getUsers(): Promise<User[]>;
    private setInCache;
    private getInCache;
    private _getUsers;
    getUser(): Promise<User | undefined>;
    setUser(object: any): Promise<User | undefined>;
    getOrCreateRoutair(identity: string): Promise<Routair>;
    getDeviceForContactair(contactair: string): Promise<Device | undefined>;
    insertLog(routair: Routair, device: Device, external_id: number, frame: string, contactair: string): Promise<boolean>;
    getLogAfterId(routair: Routair, last_external_id: number): Promise<DeviceLog[]>;
    getLastLogId(routair: Routair): Promise<number>;
    getLastLog(routair: Routair): Promise<DeviceLog | undefined>;
    getDevices(user: User): Promise<Device[]>;
    getDeviceForInternalSerial(internal_serial: string): Promise<Device | undefined>;
    setDevice(user_id: number, device: any): Promise<Device | undefined>;
    setDevices(user: User, devices: any): Promise<Device[]>;
    _getUserId(user: User): Promise<number | undefined>;
    setOnBoarding(status: boolean): Promise<any>;
    setConfig(key: string, value: string): Promise<any>;
    _localDevice?: LocalDevice;
    getLocalDevice(): Promise<LocalDevice | undefined>;
    getOnBoardingStatus(): Promise<boolean>;
    private _getOnBoardingStatus;
    getConfigValue(key: string): Promise<string | undefined>;
}
