var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import uuidv4 from "uuid/v4";
import SQLite from "react-native-sqlite-storage";
import { User, Device, Routair, DeviceLog } from "../db/models";
import LocalDevice from "./LocalDevice";
/*export interface Sqlite {
  openDatabase: (...args: any) => any
}*/
var ConfigManager = /** @class */ (function () {
    function ConfigManager( /*private SQLite: Sqlite*/) {
        this._opened = false;
        this._users = [];
        this._list_users = [];
        this._users_by_id = [];
        this._users_by_persistence_token = [];
        this._devices = [];
        this._devices_contactair = [];
        this._known_contactair = [];
        this.onBoarding = null;
    }
    ConfigManager.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._openDatabase()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ConfigManager.prototype._openDatabase = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (this._opened)
                    return [2 /*return*/, true];
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var openCallback = function () {
                            _this.openCallback().then(function () { return resolve(true); }).catch(function (err) { return reject(err); });
                        };
                        var fn = SQLite.openDatabase;
                        _this._db = fn("config_manager.db", "1.0", "config db", 200000, openCallback, function (err) { return reject(err); });
                    })];
            });
        });
    };
    ConfigManager.prototype.openCallback = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tx, users, e_1, e2_1, e3_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.transaction()];
                    case 1:
                        tx = _a.sent();
                        if (!tx)
                            throw "openCallback :: transaction was invalid";
                        return [4 /*yield*/, Promise.all([
                                this._queryTransaction(tx, "CREATE TABLE IF NOT EXISTS Config (id integer primary key autoincrement, key text, value text)", [], true),
                                this._queryTransaction(tx, "CREATE TABLE IF NOT EXISTS User (id integer primary key autoincrement, login text, email text, persistence_token text, company text, address text, city text, lastname text, surname text, postalcode text, state text, website text, guid text, phone text)", [], true),
                                this._queryTransaction(tx, "CREATE TABLE IF NOT EXISTS Device (id integer primary key autoincrement, user_id integer, serial text default null, internal_serial text default null, product_id integer default 0)", [], true),
                                this._queryTransaction(tx, "CREATE TABLE IF NOT EXISTS Routair (id integer primary key autoincrement, identity text default null)", [], true),
                                this._queryTransaction(tx, "CREATE TABLE IF NOT EXISTS DeviceLog (id integer primary key autoincrement, routair_id integer, external_id integer default 0, device_id integer default null, internal_serial text default null, contactair text default null, frame text default null, timestamp integer default 0, behaviour_state integer default 0, connected_state integer default 0)", [], true)
                            ])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN rights text default null;", [], true)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN company text default null;", [], true)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN address text default null;", [], true)];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN city text default null;", [], true)];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN lastname text default null;", [], true)];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN surname text default null;", [], true)];
                    case 8:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN postalcode text default null;", [], true)];
                    case 9:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN phone text default null;", [], true)];
                    case 10:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN firstname text default null;", [], true)];
                    case 11:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN state text default null;", [], true)];
                    case 12:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN vault_size bigint default 0;", [], true)];
                    case 13:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN gems bigint default 0;", [], true)];
                    case 14:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN website text default null;", [], true)];
                    case 15:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE Installation ADD COLUMN mode integer default 0;", [], true)];
                    case 16:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE Device ADD COLUMN is_demo integer default 0;", [], true)];
                    case 17:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN lightning_radius integer default 5;", [], true)];
                    case 18:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE User ADD COLUMN lightning_notification_type text default 'none';", [], true)];
                    case 19:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE Project ADD COLUMN delta_latitude_meter real default null;", [], true)];
                    case 20:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE Project ADD COLUMN delta_longitude_meter real default null;", [], true)];
                    case 21:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE Building ADD COLUMN delta_latitude_meter real default null;", [], true)];
                    case 22:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE Building ADD COLUMN delta_longitude_meter real default null;", [], true)];
                    case 23:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE BuildingItem ADD COLUMN delta_latitude_meter real default null;", [], true)];
                    case 24:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE BuildingItem ADD COLUMN delta_longitude_meter real default null;", [], true)];
                    case 25:
                        _a.sent();
                        return [4 /*yield*/, this._getUsers(true)];
                    case 26:
                        users = _a.sent();
                        console.warn("users?", JSON.stringify(users.map(function (u) { return u.id + " " + u.email() + " " + u.token(); })));
                        _a.label = 27;
                    case 27:
                        _a.trys.push([27, 30, , 31]);
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE DeviceLog ADD INDEX `routair_id` (`routair_id`);", [], true)];
                    case 28:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "CREATE INDEX `device_idDeviceLog` ON DeviceLog (`device_id`);", [], true)];
                    case 29:
                        _a.sent();
                        return [3 /*break*/, 31];
                    case 30:
                        e_1 = _a.sent();
                        return [3 /*break*/, 31];
                    case 31:
                        _a.trys.push([31, 34, , 35]);
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE DeviceLog ADD COLUMN timestamp integer default 0;", [], true)];
                    case 32:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "CREATE INDEX `timestampDeviceLog` ON DeviceLog (`timestamp`);", [], true)];
                    case 33:
                        _a.sent();
                        return [3 /*break*/, 35];
                    case 34:
                        e2_1 = _a.sent();
                        return [3 /*break*/, 35];
                    case 35:
                        _a.trys.push([35, 38, , 39]);
                        return [4 /*yield*/, this._queryTransaction(tx, "ALTER TABLE DeviceLog ADD COLUMN contactair text default null;", [], true)];
                    case 36:
                        _a.sent();
                        return [4 /*yield*/, this._queryTransaction(tx, "CREATE INDEX `contactairDeviceLog` ON DeviceLog (`contactair`);", [], true)];
                    case 37:
                        _a.sent();
                        return [3 /*break*/, 39];
                    case 38:
                        e3_1 = _a.sent();
                        return [3 /*break*/, 39];
                    case 39:
                        this._opened = true;
                        return [2 /*return*/, true];
                }
            });
        });
    };
    ConfigManager.prototype.transaction = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        try {
                            var transaction = {
                                executeSql: function (sqlStatement, args, callback, errorCallback) {
                                    var _a;
                                    return (_a = _this._db) === null || _a === void 0 ? void 0 : _a.executeSql(sqlStatement, args, callback, errorCallback);
                                }
                            };
                            resolve(transaction);
                            //this._db.transaction((tx: any) => resolve(tx), (err: any) => reject({ err: err }));
                        }
                        catch (err) {
                            reject(err);
                        }
                    })];
            });
        });
    };
    ConfigManager.prototype._executeSql = function (tx, query, params) {
        return __awaiter(this, void 0, void 0, function () {
            var promise, result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._db)
                            throw "no db";
                        promise = new Promise(function (resolve, reject) {
                            var _a;
                            var success = function (tx, set) {
                                var converted = tx;
                                if (converted && converted.rows)
                                    resolve(converted);
                                else
                                    resolve(set);
                            };
                            var error = function (tx, error) {
                                reject(error);
                            };
                            (_a = _this._db) === null || _a === void 0 ? void 0 : _a.executeSql(query, params, success, error);
                        });
                        return [4 /*yield*/, promise];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ConfigManager.prototype._queryTransaction = function (transaction, query, params, inOpen) {
        if (params === void 0) { params = []; }
        if (inOpen === void 0) { inOpen = false; }
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this._executeSql(transaction, query, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        //show_exception && console.log("exception during opening", err);
                        if (inOpen)
                            return [2 /*return*/, undefined];
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ConfigManager.prototype.queryTransaction = function (tx, query, params, skipFailure) {
        if (params === void 0) { params = []; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._queryTransaction(tx, query, params, skipFailure)];
            });
        });
    };
    ConfigManager.prototype.query = function (query, params) {
        if (params === void 0) { params = []; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._query(query, params)];
            });
        });
    };
    ConfigManager.prototype._query = function (query, params, inOpen) {
        if (params === void 0) { params = []; }
        if (inOpen === void 0) { inOpen = false; }
        return __awaiter(this, void 0, void 0, function () {
            var transaction, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.transaction()];
                    case 1:
                        transaction = _a.sent();
                        if (!transaction)
                            throw "invalid transaction in _query";
                        return [4 /*yield*/, this._queryTransaction(transaction, query, params)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_2 = _a.sent();
                        //show_exception && console.log("exception during opening", err);
                        if (inOpen)
                            return [2 /*return*/, undefined];
                        throw err_2;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ConfigManager.prototype.logout = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._query("UPDATE User SET persistence_token = NULL")];
            });
        });
    };
    ConfigManager.prototype.getUsers = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._getUsers(false)];
            });
        });
    };
    ConfigManager.prototype.setInCache = function (user) {
        if (!this._users_by_id[user.id]) {
            this._users_by_id[user.id] = user;
        }
        if (!this._users[user.uuid()]) {
            this._users[user.uuid()] = user;
        }
        var token = user.token();
        if (token && !this._users_by_persistence_token[token]) {
            this._users_by_persistence_token[token] = user;
        }
    };
    ConfigManager.prototype.getInCache = function (guid, token) {
        if (token && this._users_by_persistence_token[token]) {
            return this._users_by_persistence_token[token];
        }
        if (this._users[guid]) {
            return this._users[guid];
        }
        return undefined;
    };
    ConfigManager.prototype._getUsers = function (inOpen) {
        return __awaiter(this, void 0, void 0, function () {
            var query, result, i, row, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = "SELECT * FROM USER ORDER BY id ASC";
                        return [4 /*yield*/, this._query(query, [], !!inOpen)];
                    case 1:
                        result = _a.sent();
                        if (!result || !result.rows || result.rows.length <= 0)
                            return [2 /*return*/, []];
                        i = 0;
                        for (; i < result.rows.length; i++) {
                            row = result.rows.item(i);
                            if (!this._users_by_id[row.id]) {
                                user = new User(row.id, row.guid, row.login, row.email, row.persistence_token, row.rights, row.company, row.address, row.city, row.firstname, row.lastname, row.surname, row.postalcode, row.state, row.website, row.phone, row.vault_size, row.gems, row.lightning_radius, row.lightning_notification_type);
                                this.setInCache(user);
                                this._list_users.push(user);
                            }
                        }
                        return [2 /*return*/, this._list_users];
                }
            });
        });
    };
    ConfigManager.prototype.getUser = function () {
        return __awaiter(this, void 0, void 0, function () {
            var users;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getUsers()];
                    case 1:
                        users = _a.sent();
                        return [2 /*return*/, users.find(function (u) {
                                var token = u.token();
                                return !!token && token.length > 0;
                            })];
                }
            });
        });
    };
    ConfigManager.prototype.setUser = function (object) {
        return __awaiter(this, void 0, void 0, function () {
            var rights, column_names, user, questions, questions, columns, id, inserted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(object && object.guid && object.email && object.persistence_token)) return [3 /*break*/, 5];
                        rights = (object.rights || []).join(",");
                        column_names = [
                            "email", "login", "persistence_token", "guid", "rights", "company", "address", "city", "firstname", "lastname", "surname", "postalcode", "state", "website", "phone", "vault_size", "gems", "lightning_radius", "lightning_notification_type"
                        ];
                        user = this.getInCache(object.guid, object.persistence_token);
                        if (!user) return [3 /*break*/, 1];
                        user.setEmail(object.email)
                            .setLogin(object.login)
                            .setToken(object.persistence_token)
                            .setUuid(object.guid)
                            .setCompany(object.company)
                            .setAddress(object.address)
                            .setCity(object.city)
                            .setLastname(object.lastname)
                            .setSurname(object.surname)
                            .setFirstname(object.firstname)
                            .setPostalcode(object.postalcode)
                            .setPhone(object.phone)
                            .setState(object.state)
                            .setWebsite(object.website)
                            .setRights(rights.split(","))
                            .setVaultSize(object.vault_size)
                            .setGems(object.gems)
                            .setLightningNotificationType(object.lightning_notification_type)
                            .setLightningRadius(object.lightning_radius);
                        questions = column_names.map(function (k) { return k + "=?"; }).join(", ");
                        return [2 /*return*/, this._query("UPDATE User SET " + questions, [object.email, object.login, object.persistence_token, object.guid, rights, object.company, object.address, object.city, object.firstname, object.lastname, object.surname, object.postalcode, object.state, object.website, object.phone, object.vault_size, object.gems, object.lightning_radius, object.lightning_notification_type])
                                .then(function () { return user; })];
                    case 1:
                        questions = column_names.map(function (k) { return "?"; }).join(",");
                        columns = column_names.map(function (k) { return "`" + k + "`"; }).join(",");
                        return [4 /*yield*/, this._query("INSERT INTO User (" + columns + ") VALUES (" + questions + ")", [object.email, object.login, object.persistence_token, object.guid, rights, object.company, object.address, object.city, object.firstname, object.lastname, object.surname, object.postalcode, object.state, object.website, object.phone, object.vault_size, object.gems, object.lightning_radius, object.lightning_notification_type])
                                .then(function () { return user; })];
                    case 2:
                        _a.sent();
                        id = 0;
                        return [4 /*yield*/, this._query("SELECT id from User WHERE guid=?", [object.guid])];
                    case 3:
                        inserted = _a.sent();
                        if (inserted && inserted.rows && inserted.rows.length > 0) {
                            id = inserted.rows.item(0).id;
                        }
                        user = new User(id, object.guid, object.login, object.email, object.persistence_token, rights, object.company, object.address, object.city, object.firstname, object.lastname, object.surname, object.postalcode, object.state, object.website, object.phone, object.vault_size, object.gems, object.lightning_radius, object.lightning_notification_type);
                        this.setInCache(user);
                        return [2 /*return*/, user];
                    case 4: return [3 /*break*/, 6];
                    case 5: return [2 /*return*/, new Promise(function (resolve, reject) {
                            try {
                                throw "invalid user information";
                            }
                            catch (e) {
                                reject(e);
                            }
                        })];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ConfigManager.prototype.getOrCreateRoutair = function (identity) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._query("SELECT id, identity from Routair WHERE identity=?", [identity])
                .then(function (result) {
                if (result && result.rows && result.rows.length > 0) {
                    return result;
                }
                return _this._query("INSERT INTO Routair (`identity`) VALUES (?)", [identity])
                    .then(function (result) { return _this._query("SELECT id, identity from Routair WHERE identity=?", [identity]); });
            })
                .then(function (result) {
                if (result && result.rows && result.rows.length > 0) {
                    var i = 0;
                    for (; i < result.rows.length; i++) {
                        var row = result.rows.item(i);
                        resolve(new Routair(row.id, row.identity));
                    }
                }
                throw "invalid result !";
            })
                .catch(function (err) { return reject(err); });
        });
    };
    ConfigManager.prototype.getDeviceForContactair = function (contactair) {
        var _this = this;
        if (this._known_contactair[contactair] && this._known_contactair[contactair] == "unknown") {
            return new Promise(function (resolve, reject) {
                console.log("unknown and not yet existing");
                resolve(undefined);
            });
        }
        ;
        if (this._devices_contactair[contactair]) {
            return new Promise(function (resolve, reject) {
                console.log("contactair in cache");
                resolve(_this._devices_contactair[contactair]);
            });
        }
        return this._query("SELECT internal_serial FROM DeviceLog WHERE contactair=? AND internal_serial != 'ffffff' ORDER BY external_id DESC LIMIT 1", [contactair])
            .then(function (result) {
            if (result && result.rows && result.rows.length > 0) {
                var row = result.rows.item(0);
                return row.internal_serial;
            }
            return undefined;
        })
            .then(function (internal_serial) {
            if (internal_serial)
                return _this.getDeviceForInternalSerial(internal_serial)
                    .then(function (device) {
                    if (device)
                        _this._devices_contactair[contactair] = device;
                    return device;
                });
            console.log("unknown contactair, clear");
            _this._known_contactair[contactair] = "unknown";
            return undefined;
        });
    };
    ConfigManager.prototype.insertLog = function (routair, device, external_id, frame, contactair) {
        var _this = this;
        if (device && device.getInternalSerial() != "ffffff") {
            this._known_contactair[contactair] = "known";
        }
        return new Promise(function (resolve, reject) {
            _this._query("INSERT INTO DeviceLog (`routair_id`,`device_id`,`external_id`,`frame`,`contactair`) VALUES (?,?,?,?,?)", [routair.getId(), device ? device.getId() : null, external_id, frame, contactair])
                .then(function (result) { return resolve(true); })
                .catch(function (err) {
                console.log(err);
                resolve(false);
            });
        });
    };
    ConfigManager.prototype.getLogAfterId = function (routair, last_external_id) {
        return this._query("SELECT id, routair_id, external_id, device_id, internal_serial, frame, timestamp, contactair FROM DeviceLog WHERE routair_id=? AND external_id > ? ORDER BY external_id DESC LIMIT 1", [routair.getId(), last_external_id])
            .then(function (result) {
            var array = [];
            if (result && result.rows && result.rows.length > 0) {
                var i = 0;
                for (; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    array.push(new DeviceLog(row.id, row.external_id, row.frame, row.timestamp, row.contactair));
                }
            }
            return array;
        });
    };
    ConfigManager.prototype.getLastLogId = function (routair) {
        return this.getLastLog(routair)
            .then(function (deviceLog) {
            if (deviceLog)
                return deviceLog._external_id;
            return 1;
        });
    };
    ConfigManager.prototype.getLastLog = function (routair) {
        return this._query("SELECT id, routair_id, external_id, device_id, internal_serial, frame, timestamp, contactair FROM DeviceLog WHERE routair_id=? ORDER BY external_id DESC LIMIT 1", [routair.getId()])
            .then(function (result) {
            if (result && result.rows && result.rows.length > 0) {
                var i = 0;
                for (; i < result.rows.length; i++) {
                    var row = result.rows.item(i);
                    return new DeviceLog(row.id, row.external_id, row.frame, row.timestamp, row.contactair);
                }
            }
            return undefined;
        });
    };
    ConfigManager.prototype.getDevices = function (user) {
        var _this = this;
        return this._getUserId(user)
            .then(function (id) { return _this._query("SELECT id, serial, internal_serial, product_id, is_demo FROM Device WHERE user_id=?", [id]); })
            .then(function (devices) {
            var result = [];
            console.log("devices", devices);
            if (devices && devices.rows && devices.rows.length > 0) {
                var i = 0;
                for (; i < devices.rows.length; i++) {
                    var row = devices.rows.item(i);
                    var device = new Device(row.id, row.serial, row.internal_serial, row.product_id, row.is_demo);
                    _this._devices[row.internal_serial] = device;
                    result.push(device);
                }
            }
            return result;
        });
    };
    ConfigManager.prototype.getDeviceForInternalSerial = function (internal_serial) {
        var _this = this;
        if (this._devices[internal_serial]) {
            return new Promise(function (resolve, reject) {
                console.log("internal_serial in cache");
                resolve(_this._devices[internal_serial]);
            });
        }
        if (internal_serial && internal_serial.length > 6) {
            internal_serial = internal_serial.substring(0, 6);
        }
        return this._query("SELECT id, serial, internal_serial, product_id, is_demo FROM Device WHERE internal_serial=? LIMIT 1", [internal_serial])
            .then(function (devices) {
            if (devices && devices.rows && devices.rows.length > 0) {
                return devices;
            }
            else {
                return _this._query("INSERT INTO Device (`internal_serial`) VALUES (?)", [internal_serial])
                    .then(function (result) { return _this._query("SELECT id, serial, internal_serial, product_id, is_demo FROM Device WHERE internal_serial=? LIMIT 1", [internal_serial]); });
            }
        })
            .then(function (devices) {
            var result = [];
            console.log("devices", devices);
            if (devices && devices.rows && devices.rows.length > 0) {
                var i = 0;
                for (; i < devices.rows.length; i++) {
                    var row = devices.rows.item(i);
                    var device = new Device(row.id, row.serial, row.internal_serial, row.product_id, row.is_demo);
                    _this._devices[internal_serial] = device;
                    return device;
                }
            }
            return undefined;
        });
    };
    ConfigManager.prototype.setDevice = function (user_id, device) {
        var _this = this;
        if (!device)
            return new Promise(function (resolve) { return resolve(undefined); });
        return this.getDeviceForInternalSerial(device.internal_serial)
            .then(function (existing_device) {
            console.log(existing_device);
            if (existing_device && existing_device.getProduct() != device.product_id) {
                return _this._query("UPDATE Device SET product_id=? WHERE id=?", [device.product_id])
                    .then(function (result) {
                    existing_device.setProduct(device.product_id);
                    return existing_device;
                });
            }
            if (existing_device && existing_device.getSerial())
                return existing_device;
            if (existing_device) {
                var parameters_1 = [device.serial, existing_device.getId()];
                return _this._query("UPDATE Device SET serial=? WHERE id=?", parameters_1)
                    .then(function (result) {
                    existing_device.setSerial(device.serial);
                    return existing_device;
                });
            }
            //else create it
            var internal_serial = device.internal_serial;
            if (internal_serial && internal_serial.length > 6) {
                internal_serial = internal_serial.substring(0, 6);
            }
            var parameters = [user_id, device.serial, internal_serial, device.product_id, !!device.is_demo];
            //console.log("creating a device", parameters);
            return _this._query("INSERT INTO Device (`user_id`,`serial`,`internal_serial`,`product_id`,`is_demo`) VALUES (?,?,?,?,?)", parameters)
                .then(function (result) {
                //console.log("insert done, get the device information now");
                return _this.getDeviceForInternalSerial(device.internal_serial);
            });
        });
    };
    ConfigManager.prototype.setDevices = function (user, devices) {
        var _this = this;
        if (!devices || devices.length == 0)
            return this.getDevices(user);
        return this._query("DELETE FROM Device WHERE user_id=?", [user.uuid()])
            .then(function () {
            return new Promise(function (resolve, reject) {
                var array = [];
                var callback = function (user_id, index) {
                    if (index < devices.length) {
                        var device_1 = devices[index];
                        _this.setDevice(user_id, device_1)
                            .then(function (existing_device) {
                            if (existing_device)
                                array.push(existing_device);
                            else
                                console.log("ERROR INVALID DEVICE", device_1);
                            callback(user_id, index + 1);
                        });
                    }
                    else {
                        resolve(array);
                    }
                };
                _this._getUserId(user)
                    .then(function (id) { return callback(id ? id : 1, 0); })
                    .catch(function (err) { return reject(err); });
            });
        });
    };
    ConfigManager.prototype._getUserId = function (user) {
        return this._query("SELECT id FROM USER WHERE guid=? LIMIT 1", [user.uuid()])
            .then(function (result) {
            if (result && result.rows && result.rows.length > 0) {
                var i = 0;
                for (; i < result.rows.length; i++) {
                    return result.rows.item(i).id;
                }
            }
            return undefined;
        });
    };
    ConfigManager.prototype.setOnBoarding = function (status) {
        return __awaiter(this, void 0, void 0, function () {
            var value, bool;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._getOnBoardingStatus()];
                    case 1:
                        value = _a.sent();
                        bool = !!status ? "true" : null;
                        if (undefined == value) {
                            return [2 /*return*/, this._query("INSERT INTO Config (`key`, `value`) VALUES ('onboarding', ?);", [bool])];
                        }
                        return [2 /*return*/, this._query("UPDATE Config SET value=? WHERE key='onboarding'", [bool])];
                }
            });
        });
    };
    ConfigManager.prototype.setConfig = function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var config_value;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConfigValue(key)];
                    case 1:
                        config_value = _a.sent();
                        if (undefined === config_value || null === config_value) {
                            return [2 /*return*/, this._query("INSERT INTO Config (`key`, `value`) VALUES (?, ?);", [key, value])];
                        }
                        return [2 /*return*/, this._query("UPDATE Config SET value=? WHERE key=?", [value, key])];
                }
            });
        });
    };
    ConfigManager.prototype.getLocalDevice = function () {
        return __awaiter(this, void 0, void 0, function () {
            var results, hash, recovery;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._localDevice)
                            return [2 /*return*/, this._localDevice];
                        return [4 /*yield*/, Promise.all([
                                this.getConfigValue("device_uuid"),
                                this.getConfigValue("device_recovery")
                            ])];
                    case 1:
                        results = _a.sent();
                        hash = results[0];
                        recovery = results[1];
                        if (!(!hash || !recovery)) return [3 /*break*/, 3];
                        hash = uuidv4();
                        recovery = uuidv4();
                        return [4 /*yield*/, Promise.all([
                                this.setConfig("device_uuid", hash || ""),
                                this.setConfig("device_recovery", hash || "")
                            ])];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        this._localDevice = new LocalDevice(hash || "", recovery || "");
                        return [2 /*return*/, this._localDevice];
                }
            });
        });
    };
    ConfigManager.prototype.getOnBoardingStatus = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._getOnBoardingStatus()];
            });
        });
    };
    ConfigManager.prototype._getOnBoardingStatus = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.getConfigValue("onboarding")];
                    case 1: return [2 /*return*/, !!(_a.sent())];
                    case 2:
                        err_3 = _a.sent();
                        console.log("_getOnBoardingStatus, error", err_3);
                        return [2 /*return*/, false];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ConfigManager.prototype.getConfigValue = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var query, result, err_4, i, row;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = "SELECT value FROM Config WHERE key = ? LIMIT 1";
                        result = undefined;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this._query(query, [key])];
                    case 2:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_4 = _a.sent();
                        console.log("getConfigValue, error", err_4);
                        return [3 /*break*/, 4];
                    case 4:
                        if (result && result.rows && result.rows.length > 0) {
                            i = 0;
                            for (; i < result.rows.length; i++) {
                                row = result.rows.item(i);
                                return [2 /*return*/, row.value];
                            }
                        }
                        return [2 /*return*/, undefined];
                }
            });
        });
    };
    return ConfigManager;
}());
export default ConfigManager;
//# sourceMappingURL=ConfigManager.js.map