var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import ProjectRelatedTableHelper from "../db/helpers/ProjectRelatedTableHelper";
import Project from '../db/models/Project';
import Installation from '../db/models/Installation';
import InstallationAsset from '../db/models/InstallationAsset';
import InstallableComponent from '../db/models/InstallableComponent';
import ComponentAsset from '../db/models/ComponentAsset';
import { ProjectAsset, ConductorAsset, ConductorComponent, CounterAsset, CounterComponent, FixationAsset, FixationComponent, GroundingAsset, GroundingComponent, ParatonnerreAsset, ParatonnerreComponent, StormDetectorAsset, StormDetectorComponent, ElectricalGroundingAsset, ElectricalGroundingComponent } from '../db/models';
import Query from '../db/helpers/Query';
import Verification from '../db/models/Verification';
import Message from '../db/models/Message';
import Building from '../db/models/Building';
import BuildingAsset from '../db/models/BuildingAsset';
import BuildingItem from '../db/models/BuildingItem';
import BuildingItemAsset from '../db/models/BuildingItemAsset';
import Bridge from '../db/models/Bridge';
import BridgeAsset from '../db/models/BridgeAsset';
import Antenna from '../db/models/Antenna';
import AntennaAsset from '../db/models/AntennaAsset';
import ConductorSectionAsset from '../db/models/ConductorSectionAsset';
import ConductorSectionComponent from '../db/models/ConductorSectionComponent';
import SurgeArresterAsset from '../db/models/SurgeArresterAsset';
import SurgeArresterComponent from '../db/models/SurgeArresterComponent';
import EquipotentialRecoveryAsset from '../db/models/EquipotentialRecoveryAsset';
import EquipotentialRecoveryComponent from '../db/models/EquipotentialRecoveryComponent';
import DeviceProjectRegistration from '../db/models/DeviceProjectRegistration';
import { DBCache } from '..';
import IncomingServiceAsset from '../db/models/IncomingServiceAsset';
import IncomingServiceComponent from '../db/models/IncomingServiceComponent';
function init_cache(klass) {
    if (!DBCache.has(klass.name))
        DBCache.set(klass.name, []);
}
var ProjectDatabase = /** @class */ (function () {
    function ProjectDatabase(config_manager) {
        this.config_manager = config_manager;
        this.helper = new ProjectRelatedTableHelper();
        this.descriptors = new Map();
        var self = this;
        var Q = /** @class */ (function () {
            function Q() {
            }
            Q.prototype.transaction = function () {
                return new Promise(function (resolve, reject) {
                    self.config_manager.transaction().then(function (tx) {
                        if (!tx)
                            throw "invalid transaction";
                        resolve(tx);
                    }).catch(function (err) { return reject(err); });
                });
            };
            Q.prototype.execute = function (transaction, query, args) {
                return self.config_manager.queryTransaction(transaction, query, args)
                    .then(function (result) { return ({
                    insertId: (result === null || result === void 0 ? void 0 : result.insertId) || 0,
                    rows: self.rows(result)
                }); });
            };
            Q.prototype.children = function (klass, parent_id) {
                return self.selectListFromGivenKey(klass, "parent_id", parent_id);
            };
            return Q;
        }());
        Query.query = new Q();
    }
    ProjectDatabase.prototype.init = function (optional_models) {
        if (optional_models === void 0) { optional_models = []; }
        return __awaiter(this, void 0, void 0, function () {
            var models, transaction, i, model, list;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        models = [
                            DeviceProjectRegistration,
                            EquipotentialRecoveryAsset,
                            EquipotentialRecoveryComponent,
                            ConductorSectionAsset,
                            SurgeArresterAsset,
                            SurgeArresterComponent,
                            ConductorSectionComponent,
                            ElectricalGroundingAsset,
                            ElectricalGroundingComponent,
                            IncomingServiceAsset,
                            IncomingServiceComponent,
                            Bridge,
                            BridgeAsset,
                            Antenna,
                            AntennaAsset,
                            BuildingItem,
                            BuildingItemAsset,
                            Building,
                            BuildingAsset,
                            Message,
                            Project,
                            Verification,
                            Installation,
                            InstallationAsset,
                            InstallableComponent,
                            ProjectAsset,
                            ComponentAsset,
                            ComponentAsset,
                            ConductorAsset,
                            ConductorComponent,
                            CounterAsset,
                            CounterComponent,
                            FixationAsset,
                            FixationComponent,
                            GroundingAsset,
                            GroundingComponent,
                            ParatonnerreAsset,
                            ParatonnerreComponent,
                            StormDetectorAsset,
                            StormDetectorComponent
                        ];
                        if (optional_models)
                            models = __spreadArrays(models, optional_models);
                        models.forEach(function (m) { return init_cache(m); });
                        return [4 /*yield*/, this.config_manager.init()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.config_manager.transaction()];
                    case 2:
                        transaction = _a.sent();
                        if (!transaction)
                            throw "no transaction obtained, fail...";
                        return [4 /*yield*/, Promise.all(models.map(function (klass) { return _this.creation(transaction, klass); }))];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(models.map(function (klass) { return _this.missing_date_fields(transaction, klass); }))];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, Promise.all(models.map(function (klass) { return _this.indexes(transaction, klass); }))];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, Project)];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, Building)];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ConductorComponent)];
                    case 8:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ConductorSectionComponent)];
                    case 9:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ElectricalGroundingComponent)];
                    case 10:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, IncomingServiceComponent)];
                    case 11:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, CounterComponent)];
                    case 12:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ParatonnerreComponent)];
                    case 13:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, StormDetectorComponent)];
                    case 14:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, SurgeArresterComponent)];
                    case 15:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, AntennaAsset)];
                    case 16:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, BridgeAsset)];
                    case 17:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, BuildingAsset)];
                    case 18:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, BuildingItemAsset)];
                    case 19:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ComponentAsset)];
                    case 20:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ConductorAsset)];
                    case 21:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ConductorSectionAsset)];
                    case 22:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, CounterAsset)];
                    case 23:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, EquipotentialRecoveryAsset)];
                    case 24:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, EquipotentialRecoveryComponent)];
                    case 25:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, FixationAsset)];
                    case 26:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, FixationComponent)];
                    case 27:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, GroundingAsset)];
                    case 28:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, GroundingComponent)];
                    case 29:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, InstallationAsset)];
                    case 30:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, Installation)];
                    case 31:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ParatonnerreAsset)];
                    case 32:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, ProjectAsset)];
                    case 33:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, StormDetectorAsset)];
                    case 34:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, SurgeArresterAsset)];
                    case 35:
                        _a.sent();
                        return [4 /*yield*/, this.migrate(transaction, Verification)];
                    case 36:
                        _a.sent();
                        return [4 /*yield*/, this.config_manager.queryTransaction(transaction, "ALTER TABLE Project ADD COLUMN language text default null;", [], true)];
                    case 37:
                        _a.sent();
                        return [4 /*yield*/, this.config_manager.queryTransaction(transaction, "ALTER TABLE Verification ADD COLUMN is_simulation integer default null;", [], true)];
                    case 38:
                        _a.sent();
                        i = 0;
                        _a.label = 39;
                    case 39:
                        if (!(i < models.length)) return [3 /*break*/, 41];
                        model = models[i];
                        console.log("getting for " + model.name + " ...");
                        return [4 /*yield*/, this.fetchFromDatabase(transaction, model)];
                    case 40:
                        list = _a.sent();
                        console.log("getting for " + model.name + " is : " + list.length);
                        DBCache.set(model.name, list);
                        i++;
                        return [3 /*break*/, 39];
                    case 41: return [2 /*return*/, true];
                }
            });
        });
    };
    ProjectDatabase.prototype.drops = function (optional_models) {
        if (optional_models === void 0) { optional_models = []; }
        return __awaiter(this, void 0, void 0, function () {
            var models, transaction;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        models = [Project, Verification, Installation, InstallationAsset, InstallableComponent, ProjectAsset, ComponentAsset];
                        if (optional_models)
                            models = __spreadArrays(models, optional_models);
                        return [4 /*yield*/, this.config_manager.transaction()];
                    case 1:
                        transaction = _a.sent();
                        if (!transaction)
                            throw "invalid transaction in drops";
                        return [4 /*yield*/, Promise.all(models.map(function (klass) { return _this.drop(transaction, klass); }))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * Instantiate - does not save, an instance of a given Klass
     * @param param the json representing data to populate the object
     * @param klass the reprenting holding Class of the holder of the data
     */
    ProjectDatabase.prototype.instantiate = function (param, klass) {
        var instance = new klass(param);
        instance.init(instance);
        return instance;
    };
    ProjectDatabase.prototype.populate = function (instance) {
        return instance.populate();
    };
    ProjectDatabase.prototype.select = function (klass, id) {
        return this.selectFromGivenKey(klass, "id", id);
    };
    ProjectDatabase.prototype.selectChildren = function (klass, parent_id) {
        return this.selectListFromGivenKey(klass, "parent_id", parent_id);
    };
    ProjectDatabase.prototype.selectFromUUID = function (klass, uuid) {
        return this.selectFromGivenKey(klass, "uuid", uuid);
    };
    ProjectDatabase.prototype.list = function (klass) {
        return this.selectListFromGivenKey(klass);
    };
    ProjectDatabase.prototype.fetchFromDatabase = function (transaction, klass) {
        var _this = this;
        var descriptor = this.descriptor(klass);
        if (!descriptor)
            return this.reject(klass);
        return this.config_manager.queryTransaction(transaction, this.helper.createSelectionQuery(descriptor), [])
            .then(function (result) { return _this.rows(result); })
            .then(function (rows) {
            if (rows) {
                return rows.map(function (row) { return _this.instantiate(row, klass); });
            }
            return [];
        });
    };
    ProjectDatabase.prototype.log = function (array) {
        console.log("log", { array: array });
        return array;
    };
    ProjectDatabase.prototype.drop = function (transaction, klass) {
        return __awaiter(this, void 0, void 0, function () {
            var descriptor, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        descriptor = this.descriptor(klass);
                        if (!descriptor)
                            return [2 /*return*/, this.reject(klass)];
                        return [4 /*yield*/, this.config_manager.queryTransaction(transaction, this.helper.drop(descriptor))];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, !!result];
                }
            });
        });
    };
    ProjectDatabase.prototype.selectListFromGivenKey = function (klass, selector_key, index) {
        return __awaiter(this, void 0, void 0, function () {
            var list;
            return __generator(this, function (_a) {
                list = DBCache.get(klass.name);
                /*if(null == list || list.length == 0) {
                    console.log("fallback trying to get info for " + klass.name);
        
                    const from_database = await this.fetchFromDatabase(klass);
                    console.log("found ! " + from_database.length);
                    list = from_database;
                    DBCache.set(klass.name, list);
                }*/
                if (selector_key) {
                    return [2 /*return*/, list.filter(function (item) { return item[selector_key] == index; })];
                }
                return [2 /*return*/, list];
            });
        });
    };
    ProjectDatabase.prototype.selectFromGivenKey = function (klass, selector_key, index) {
        return this.selectListFromGivenKey(klass, selector_key, index)
            .then(function (list) { return list && list.length > 0 ? list[0] : undefined; });
        /*
        const descriptor: DbDescriptor|undefined = this.descriptor(klass);
        if(!descriptor) return this.reject(klass);

        return this.config_manager._query(this.helper.createSelectionQuery(descriptor, selector_key), index ? [index] : [])
        .then(result => {
            result = this.rows(result);
            //console.log("selectFromGivenKey list from selector_key:= " + selector_key +" index:=" +index, result);

            if(result && result.length > 0) {
                return this.instantiate(result[0], klass);
            }

            return undefined;
        });
        */
    };
    //TODO add generic delete for the future
    ProjectDatabase.prototype.deleteMessage = function (message) {
        return __awaiter(this, void 0, void 0, function () {
            var descriptor;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        descriptor = this.descriptor(Message);
                        if (!descriptor)
                            return [2 /*return*/, this.reject(Message)];
                        return [4 /*yield*/, this.config_manager.query(this.helper.createDeleteQuery(descriptor, "id"), [message.id])];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, true];
                }
            });
        });
    };
    ProjectDatabase.prototype.rows = function (results) {
        var rows = [];
        if (!results || !results.rows)
            return rows;
        for (var i = 0; i < results.rows.length; i++) {
            rows.push(results.rows.item(i));
        }
        return rows;
    };
    ProjectDatabase.prototype.missing_date_fields = function (transaction, klass) {
        var instance = new klass({});
        instance.init(instance);
        return this.config_manager.queryTransaction(transaction, "ALTER TABLE " + instance.constructor.name + " ADD COLUMN date_unknown integer default null;", [], true);
    };
    ProjectDatabase.prototype.creation = function (transaction, klass) {
        var instance = new klass({});
        instance.init(instance);
        if (!instance.descriptor)
            throw "invalid creation called for " + klass.name;
        this.descriptors.set(klass, instance.descriptor);
        this.descriptors.set(instance.constructor.name, instance.descriptor);
        console.log("creation for " + instance.constructor.name);
        return this.config_manager.queryTransaction(transaction, this.helper.createTableCreationQuery(instance.descriptor), [], true);
    };
    ProjectDatabase.prototype.migrate = function (transaction, klass) {
        return __awaiter(this, void 0, void 0, function () {
            var instance, migration, index;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        instance = new klass({});
                        instance.init(instance);
                        if (!instance.descriptor)
                            throw "invalid creation called for " + klass.name;
                        this.descriptors.set(klass, instance.descriptor);
                        this.descriptors.set(instance.constructor.name, instance.descriptor);
                        migration = instance.descriptor.migration();
                        index = 0;
                        _a.label = 1;
                    case 1:
                        if (!(index < migration.length)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.config_manager.queryTransaction(transaction, migration[index], [], true)];
                    case 2:
                        _a.sent();
                        index++;
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ProjectDatabase.prototype.indexes = function (transaction, klass) {
        var _this = this;
        var descriptor = this.descriptor(klass);
        if (!descriptor)
            return this.reject(klass);
        return Promise.all(this.helper.createIndexes(descriptor).map(function (q) { return _this.config_manager.queryTransaction(transaction, q, [], true); }));
    };
    ProjectDatabase.prototype.reject = function (k) {
        //console.log("rejecting klass", k)
        return new Promise(function () { throw "rejecting due to invalid klass"; });
    };
    ProjectDatabase.prototype.descriptor = function (k) {
        if (this.descriptors.has(k))
            return this.descriptors.get(k);
        if (k.name && this.descriptors.has(k.name))
            return this.descriptors.get(k.name);
        var name = new k({}).constructor.name;
        if (this.descriptors.has(name))
            return this.descriptors.get(name);
        return undefined;
    };
    return ProjectDatabase;
}());
export default ProjectDatabase;
//# sourceMappingURL=ProjectDatabase.js.map