var createLogger = function (name) {
    var _a;
    var title = "";
    if (typeof name === "string")
        title = name;
    else
        title = ((_a = name.constructor) === null || _a === void 0 ? void 0 : _a.name) || "";
    return {
        log: function (title, object) { },
        warn: function (title, object) { },
        error: function (title, object) { },
        trace: function (title, object) { },
        enable: function (value) { }
    };
};
var isDev = false;
try {
    isDev = __DEV__;
}
catch (err) {
}
if (isDev) {
    var Logger_1 = /** @class */ (function () {
        function Logger(title) {
            this.title = title;
            this.enabled = true;
        }
        Logger.prototype.log = function (name, object) {
            if (!this.enabled)
                return;
            if (arguments.length == 2)
                console.log(this.title + " D :: " + name, object);
            else
                console.log(this.title + " D :: " + name);
        };
        Logger.prototype.warn = function (name, object) {
            if (!this.enabled)
                return;
            if (arguments.length == 2)
                console.log(this.title + " W :: " + name, object);
            else
                console.log(this.title + " W :: " + name);
        };
        Logger.prototype.error = function (name, object) {
            if (!this.enabled)
                return;
            if (arguments.length == 2)
                console.error(this.title + " E :: " + name, object);
            else
                console.error(this.title + " E :: " + name);
        };
        Logger.prototype.trace = function (name, object) {
            if (!this.enabled)
                return;
            if (arguments.length == 2)
                console.trace(this.title + " T :: " + name, object);
            else
                console.trace(this.title + " T :: " + name);
        };
        Logger.prototype.enable = function (enabled) {
            this.enabled = enabled;
        };
        return Logger;
    }());
    createLogger = function (name) {
        var _a;
        var title = "";
        if (typeof name === "string")
            title = name;
        else
            title = ((_a = name.constructor) === null || _a === void 0 ? void 0 : _a.name) || "";
        var logger = new Logger_1(title);
        return {
            log: logger.log.bind(logger),
            warn: logger.warn.bind(logger),
            error: logger.error.bind(logger),
            trace: logger.trace.bind(logger),
            enable: logger.enable.bind(logger)
        };
    };
}
export default createLogger;
//# sourceMappingURL=Logger.js.map