import { ProtectionLevel } from "../db/helpers/ProtectionLevel";
import { getCD } from "../db/helpers/Cd";
import { getDanger } from "../db/helpers/Danger";
import { getRiskFire } from "../db/helpers/RiskFire";
import { getOccupation } from "../db/helpers/Occupation";
import { getServiceSurgeArrester } from "../db/helpers/Spf";
import { ServiceEntrant, getServiceEntrant } from "../db/helpers/ServiceEntrant";
import { ServiceType } from "../db/helpers/ServiceType";
var Protection = /** @class */ (function () {
    function Protection(Ng, longueur, largeur, hauteur, hauteurMax, ParamCd, incendie, dangers, occupation, service1, 
    //public service1_type: ServiceType,
    //public service2: ServiceEntrant,
    //public service2_type: ServiceType,
    //public service2_parafoudre: any,
    inacceptable_loss) {
        var _this = this;
        this.Ng = Ng;
        this.longueur = longueur;
        this.largeur = largeur;
        this.hauteur = hauteur;
        this.hauteurMax = hauteurMax;
        this.ParamCd = ParamCd;
        this.incendie = incendie;
        this.dangers = dangers;
        this.occupation = occupation;
        this.service1 = service1;
        this.inacceptable_loss = inacceptable_loss;
        this.surface = function () { return _this.longueur * _this.largeur; };
        this.Adglobal = function () { return _this.longueur * _this.largeur +
            6 * _this.hauteur * (_this.longueur + _this.largeur) +
            9 * Math.PI * (_this.hauteur * _this.hauteur); };
        this.Adp = function () { return 9 * Math.PI * _this.hauteurMax * _this.hauteurMax; };
        this.Ad = function () { return Math.max(_this.Adglobal(), _this.Adp()); };
        this.Cd = function () { return getCD(_this.ParamCd); };
        this.ND = function () { return _this.Ng * _this.Ad() * _this.Cd() * Math.pow(10, -6); };
        this.AI = function () {
            //if(this.service1_type == ServiceType.POWER_OR_COMMUNICATION) {
            //    return getServiceEntrant(this.service1);
            //} else if(this.service2_type == ServiceType.POWER_OR_COMMUNICATION) {
            //    return getServiceEntrant(this.service2);
            //}
            //return getServiceEntrant(ServiceEntrant.NONE);
            return getServiceEntrant(_this.service1 || ServiceEntrant.NONE);
        };
        this.NI = function () { return _this.Ng * _this.AI() * Math.pow(10, -6); };
        this.PI = function (protection_level) { return getServiceSurgeArrester(protection_level); };
        this.hz = function () { return getDanger(_this.dangers); };
        this.rf = function () { return getRiskFire(_this.incendie); };
        this.Lf1 = function () { return getOccupation(_this.occupation); };
        this.LD1 = function () { return _this.hz() * _this.rf() * _this.Lf1(); };
        this.LI1 = function () { return _this.LD1(); };
        this.Lf2 = function () {
            switch (_this.inacceptable_loss) {
                case ServiceType.POWER_OR_COMMUNICATION: return 0.01;
                case ServiceType.GAZ_WATER: return 0.01;
                default: return 0;
            }
        };
        this.LD2 = function () { return _this.rf() * _this.Lf2(); };
        this.LI2 = function () { return _this.LD2(); };
        this.LD3 = function () { return _this.rf() * Math.pow(10, -1); };
        this.LI3 = function () { return _this.LD3(); };
        this.PD = function (protection_level) {
            switch (protection_level) {
                case ProtectionLevel.LEVEL_4: return 0.2;
                case ProtectionLevel.LEVEL_3: return 0.1;
                case ProtectionLevel.LEVEL_2: return 0.05;
                case ProtectionLevel.LEVEL_1: return 0.02;
                case ProtectionLevel.UNKNOWN:
                default:
                    return 1;
            }
        };
        this.RD1 = function (level) { return _this.ND() * _this.PD(level) * _this.LD1(); };
        this.RI1 = function (level) { return _this.NI() * _this.PI(level) * _this.LI1(); };
        this.R1 = function (level) { return _this.RD1(level) + _this.RI1(level); };
        this.RD2 = function (level) { return _this.ND() * _this.PD(level) * _this.LD2(); };
        this.RI2 = function (level) { return _this.NI() * _this.PI(level) * _this.LI2(); };
        this.R2 = function (level) { return _this.RD2(level) + _this.RI2(level); };
        this.RD3 = function (level) { return _this.ND() * _this.PD(level) * _this.LD3(); };
        this.RI3 = function (level) { return _this.NI() * _this.PI(level) * _this.LI3(); };
        this.R3 = function (level) { return _this.RD3(level) + _this.RI3(level); };
        this.isRT1Valid = function (level) { return _this.R1(level) < 0.00001; };
        this.isRT2Valid = function (level) { return _this.R2(level) < 0.001; };
        this.isRT3Valid = function (level) { return _this.R3(level) < 0.0001; };
        this.calculs_structure = function () { return ({
            surface: _this.surface(),
            Adp: _this.Adp(),
            Adglobal: _this.Adglobal(),
            Ad: _this.Ad(),
            ND: _this.ND(),
        }); };
        this.create_stub = function (protection_level) { return ({
            protection_level: protection_level,
            isRT1Valid: false,
            isRT2Valid: false,
            isRT3Valid: false,
            valid: false,
        }); };
        this.calculs_risques = function () {
            var result = {
                level_1: _this.create_stub(ProtectionLevel.LEVEL_1),
                level_2: _this.create_stub(ProtectionLevel.LEVEL_2),
                level_3: _this.create_stub(ProtectionLevel.LEVEL_3),
                level_4: _this.create_stub(ProtectionLevel.LEVEL_4),
                none: _this.create_stub(ProtectionLevel.UNKNOWN),
            };
            Object.keys(result).forEach(function (k) {
                var numberValidRT = 0;
                var protection_level = result[k].protection_level;
                result[k].isRT1Valid = _this.isRT1Valid(protection_level),
                    result[k].isRT2Valid = _this.isRT2Valid(protection_level),
                    result[k].isRT3Valid = _this.isRT3Valid(protection_level),
                    ["isRT1Valid", "isRT2Valid", "isRT3Valid"].forEach(function (RT) { return (!!result[k][RT]) && (numberValidRT++); });
                result[k].valid = !!(numberValidRT == 3);
            });
            return result;
        };
        this.calculs_services = function () { return ({
            Cd: _this.Cd(),
            ND: _this.ND(),
            AI: _this.AI(),
            NI: _this.NI(),
            PI_level_1: _this.PI(ProtectionLevel.LEVEL_1),
            PI_level_2: _this.PI(ProtectionLevel.LEVEL_2),
            PI_level_3: _this.PI(ProtectionLevel.LEVEL_3),
            PI_level_4: _this.PI(ProtectionLevel.LEVEL_4),
            PI_level_unknown: _this.PI(ProtectionLevel.UNKNOWN),
            hz: _this.hz(),
            rf: _this.rf(),
            Lf1: _this.Lf1(),
            LD1: _this.LD1(),
            LI1: _this.LI1(),
            Lf2: _this.Lf2(),
            LD2: _this.LD2(),
            LI2: _this.LI2(),
            LD3: _this.LD3(),
            LI3: _this.LI3(),
            PD_level_1: _this.PD(ProtectionLevel.LEVEL_1),
            PD_level_2: _this.PD(ProtectionLevel.LEVEL_2),
            PD_level_3: _this.PD(ProtectionLevel.LEVEL_3),
            PD_level_4: _this.PD(ProtectionLevel.LEVEL_4),
            PD_level_unknown: _this.PD(ProtectionLevel.UNKNOWN),
        }); };
        this.calcul_protection_level = function () {
            var result = _this.calculs_risques();
            //we actually test if none -> 4 -> 3 -> 2 -> 1
            var found_key = ["level_1", "level_2", "level_3", "level_4", "none"].reverse().find(function (k) { return !!result[k].valid; });
            if (!found_key)
                return undefined;
            return result[found_key].protection_level;
            /*if(result.level_1.valid) return ProtectionLevel.LEVEL_1;
            if(result.level_2.valid) return ProtectionLevel.LEVEL_2;
            if(result.level_3.valid) return ProtectionLevel.LEVEL_3;
            if(result.level_4.valid) return ProtectionLevel.LEVEL_4;
            if(result.none.valid) return ProtectionLevel.UNKNOWN;
            return undefined;*/
        };
    }
    return Protection;
}());
export default Protection;
//# sourceMappingURL=Protection.js.map