var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import moment from 'moment';
import { transformIntoTextKey } from "../db/helpers/FieldHelper";
var LOGIN = "/v1/user/login.json";
var PROFILE = "/v1/user/profile.json";
var REGISTER = "/v1/user/register.json";
var DEVICES = "/v1/user/devices.json";
var PUSH = "/v1/user/push.json";
var REPORT = "/v1/devices/report.json";
var REGISTER_LIGHT = "/v2/light/register.json";
var DEVICE_LIGHT = "/v2/light/device.json";
var ADD_LIGHT = "/v2/light/add.json";
var WEATHER = "/v2/weather.json";
var REPORT_WEATHER = "/v2/weather/history.json";
var REPORT_THUNDER = "/v2/weather/thunder.json";
var DEVICES_LIGHT = "/v2/user/devices.json";
var DEVICE = "/v1/device/";
var REFRESH_PROJECTS = "/v2/projects/refresh";
var REGISTER_DEVICE_PROJECT = "/v3/alert/register.json";
var V3_ROOT = "/v3";
var GET_USER_IAP = "/v3/user/iap.json";
var GET_ROUTAIR_DATA = "/v3/data/routair/";
var GET_REGISTRY = "/v3/data/registry";
var GET_1GIGA = "/v3/user/gems/to1giga";
var GET_10GIGA = "/v3/user/gems/to10giga";
var CONVERSATIONS = "/v3/conversations";
var MESSAGES = "/v3/conversation/";
function safe(str) {
    return str ? str.replace(/[^0-9a-zA-Z\-\_]/gi, '') : "";
}
var _fetch = function (url, method, post, auth) { return __awaiter(void 0, void 0, void 0, function () {
    var options, response, error, text;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                options = {
                    method: method,
                    headers: {
                        'Accept': 'application/json',
                        'Content-Type': 'application/json',
                    }
                };
                if (auth) {
                    options.headers["token"] = auth;
                }
                if (post)
                    options.body = JSON.stringify(post);
                return [4 /*yield*/, fetch(url, options)];
            case 1:
                response = _a.sent();
                if (response && response.status >= 200 && response.status < 300) {
                    return [2 /*return*/, response.json()];
                }
                error = new Error("invalid response");
                return [4 /*yield*/, response.text()];
            case 2:
                text = _a.sent();
                try {
                    error.data = JSON.parse(text);
                }
                catch (_) {
                    error.data = text;
                }
                throw error;
        }
    });
}); };
var _post = function (url, params, data, token) {
    if (token === void 0) { token = undefined; }
    url += toURI(params);
    return _fetch(url, "POST", data, token);
};
var _put = function (url, params, data, token) {
    if (token === void 0) { token = undefined; }
    url += toURI(params);
    return _fetch(url, "PUT", data, token);
};
var _get = function (url, params, auth) {
    url += toURI(params);
    return _fetch(url, "GET", undefined, auth);
};
var toURI = function (params) {
    if (!params)
        return "";
    var encode = encodeURIComponent;
    var keys = Object
        .keys(params)
        .filter(function (k) { return !!params[k]; });
    if (keys.length == 0)
        return "";
    return "?" + keys
        .map(function (k) {
        if (Array.isArray(params[k])) {
            return params[k].map(function (val) { return encode(k) + "[]=" + encode(val); }).join('&');
        }
        return encode(k) + "=" + encode(params[k]);
    })
        .join('&');
};
var LightApi = /** @class */ (function () {
    function LightApi(env) {
        this._env = env;
    }
    LightApi.prototype.register = function (localDevice, push_token) {
        return _post(this._env + REGISTER_LIGHT, undefined, { hash: localDevice.hash,
            recovery: localDevice.recovery, push_token: push_token });
    };
    LightApi.prototype.device = function (code) {
        return _post(this._env + DEVICE_LIGHT, undefined, { code: code })
            .then(function (result) {
            if (result) {
                var split = (result.info_location || "").split(",");
                return {
                    id: result.id || 0,
                    serial: result.serial || "",
                    internal_serial: result.internal_serial || "",
                    product_id: result.product_id || "",
                    latitude: split.length > 0 ? parseFloat(split[1]) : NaN,
                    longitude: split.length > 0 ? parseFloat(split[0]) : NaN
                };
            }
            throw "no device";
        });
    };
    LightApi.prototype.add = function (localDevice, code) {
        return _post(this._env + ADD_LIGHT, undefined, { hash: localDevice.hash,
            recovery: localDevice.recovery, code: code });
    };
    LightApi.prototype.devices = function (localDevice) {
        return _post(this._env + DEVICES_LIGHT, undefined, { hash: localDevice.hash,
            recovery: localDevice.recovery });
    };
    return LightApi;
}());
export { LightApi };
var SyncApi = /** @class */ (function () {
    function SyncApi(env, Upload, downloadFile, downloadStop) {
        var _this = this;
        this.Upload = Upload;
        this.downloadFile = downloadFile;
        this.downloadStop = downloadStop;
        this.root = "https://9haykxmcld.execute-api.eu-west-3.amazonaws.com/prod/sync";
        this._verification_readonly = "https://api.contact-platform.com/v3/project/$1/verification/$2";
        //  private _verification_readonly: string = "https://9haykxmcld.execute-api.eu-west-3.amazonaws.com/prod/sync/project/$1/verification/$2";
        this._upload = "https://9haykxmcld.execute-api.eu-west-3.amazonaws.com/prod/upload";
        this._upload_conversation_put = "https://2lzrt7dab5.execute-api.eu-west-3.amazonaws.com/prod/conversation/{uuid}/upload";
        this._upload_conversation_get = "https://2lzrt7dab5.execute-api.eu-west-3.amazonaws.com/prod/conversation/{uuid}/upload/{key}";
        this._avatar = "https://9haykxmcld.execute-api.eu-west-3.amazonaws.com/prod/upload/avatar";
        this._company_logo = "https://9haykxmcld.execute-api.eu-west-3.amazonaws.com/prod/upload/company_logo";
        this._avatar_public = "https://lpsfrmanager.s3.eu-west-3.amazonaws.com/avatars";
        this._company_logo_public = "https://lpsfrmanager.s3.eu-west-3.amazonaws.com/company_logo";
        this._persistence_token = "";
        this.setAuthToken = function (persistence_token) { return _this._persistence_token = persistence_token; };
        this.clear = function () { return _get(_this.root + "/clear", undefined, _this._persistence_token); };
        this.setCompany = function (company) { return _post(_this.root + "/user/company", undefined, company, _this._persistence_token); };
        this.getCompany = function () { return _get(_this.root + "/user/company", undefined, _this._persistence_token); };
        this.getVersion = function (project, version) { return _get(_this.root + "/project/" + project + "/version/" + version, undefined, _this._persistence_token); };
        this.getLastVersion = function (project) { return _get(_this.root + "/project/" + project + "/last", undefined, _this._persistence_token); };
        this.getVersions = function (project) { return _get(_this.root + "/project/" + project + "/versions", undefined, _this._persistence_token); };
        this.getMaintenance = function (project, date) { return _get(_this.root + "/project/" + project + "/maintenance", !!date ? { last: date } : undefined, _this._persistence_token); };
        this.putMaintenance = function (project, message) { return _put(_this.root + "/project/" + project + "/maintenance", undefined, message, _this._persistence_token); };
        this.putVersion = function (project, content) { return _put(_this.root + "/project/" + project, undefined, content, _this._persistence_token); };
        this.getProjects = function () { return _get(_this.root + "/projects", undefined, _this._persistence_token); };
        this.getRights = function (project) { return _get(_this.root + "/project/" + project + "/rights", undefined, _this._persistence_token); };
        this.addRight = function (project, user) { return _put(_this.root + "/project/" + project + "/right", undefined, { user: user }, _this._persistence_token); };
        this._env = env;
    }
    SyncApi.prototype.readonly = function (project, verification) {
        var url = this._verification_readonly.replace("$1", safe(project)).replace("$2", safe(verification));
        return _get(url, undefined, "");
    };
    SyncApi.prototype.videoCallToken = function () {
        return _get(this._env + V3_ROOT + "/videocalls/token", undefined, this._persistence_token);
    };
    SyncApi.prototype.videoCallInformaton = function (conversation) {
        var main_url = "" + this._env + V3_ROOT + "/videocalls/conversation/$1";
        var url = main_url.replace("$1", safe(conversation));
        return _get(url, undefined, this._persistence_token);
    };
    SyncApi.prototype.avatarURL = function (user) {
        var uuid = (user.uuid() || "").replace(/[^0-9a-zA-Z\-\_]/gi, '');
        return this._avatar_public + "/" + uuid;
    };
    SyncApi.prototype.companyLogo = function (user) {
        var uuid = (user.uuid() || "").replace(/[^0-9a-zA-Z\-\_]/gi, '');
        return this._company_logo_public + "/" + uuid;
    };
    SyncApi.prototype.refreshProjects = function () {
        return _get(this._env + REFRESH_PROJECTS, undefined, this._persistence_token);
    };
    SyncApi.prototype.getConversations = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result, output;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _get(this._env + CONVERSATIONS, undefined, this._persistence_token)];
                    case 1:
                        result = _a.sent();
                        output = result.map(function (r) { return (__assign(__assign({}, r), { updated_at: r.updated_at ? new Date(r.updated_at) : new Date() })); });
                        return [2 /*return*/, output];
                }
            });
        });
    };
    SyncApi.prototype.createConversation = function (participants) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _put(this._env + CONVERSATIONS, undefined, { participants: participants }, this._persistence_token)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, __assign(__assign({}, result), { updated_at: result.updated_at ? new Date(result.updated_at) : new Date() })];
                }
            });
        });
    };
    SyncApi.prototype.getMessages = function (conversation) {
        return _get(this._env + MESSAGES + conversation, undefined, this._persistence_token);
    };
    SyncApi.prototype.putMessage = function (conversation, message) {
        return _put(this._env + MESSAGES + conversation, undefined, { message: message }, this._persistence_token);
    };
    SyncApi.prototype.project_files = function (project) {
        return _get(this._env + V3_ROOT + ("/data/project/" + project + "/files"), undefined, this._persistence_token);
    };
    SyncApi.prototype.project_download_file = function (project, toFile, key, begin, progress) {
        var fromUrl = this._env + V3_ROOT + ("/data/project/" + project + "/file/" + key);
        var options = {
            fromUrl: fromUrl,
            toFile: toFile,
            headers: {
                "token": this._persistence_token
            },
            background: true,
            discretionary: true,
            cacheable: true,
            //progressInterval?: number;
            //progressDivider?: number;
            begin: begin,
            progress: progress,
        };
        return this.downloadFile(options);
    };
    SyncApi.prototype.downloadCertificate = function (serial, toFile, begin, progress) {
        var fromUrl = "https://contact-platform.com/api/device/pdf/" + transformIntoTextKey(serial === null || serial === void 0 ? void 0 : serial.toLowerCase());
        var options = {
            fromUrl: fromUrl,
            toFile: toFile,
            headers: {
                "token": this._persistence_token
            },
            background: true,
            discretionary: true,
            cacheable: true,
            //progressInterval?: number;
            //progressDivider?: number;
            begin: begin,
            progress: progress,
        };
        return this.downloadFile(options);
    };
    SyncApi.prototype.downloadWarranty = function (serial, toFile, begin, progress) {
        var fromUrl = "https://contact-platform.com/api/" + this._persistence_token + "/device/pdf/warranty/" + transformIntoTextKey(serial === null || serial === void 0 ? void 0 : serial.toLowerCase());
        var options = {
            fromUrl: fromUrl,
            toFile: toFile,
            headers: {
                "token": this._persistence_token
            },
            background: true,
            discretionary: true,
            cacheable: true,
            //progressInterval?: number;
            //progressDivider?: number;
            begin: begin,
            progress: progress,
        };
        return this.downloadFile(options);
    };
    SyncApi.prototype.project_upload_file = function (project, local_path, key, mimetype, on_progress) {
        var url = this._env + V3_ROOT + ("/data/project/" + project + "/file");
        return this.uploadInternal(local_path, mimetype, url + "?key=" + key, on_progress);
    };
    SyncApi.prototype.uploadAvatar = function (local_path, mimetype, on_progress) {
        return this.uploadInternal(local_path, mimetype, "" + this._avatar, on_progress);
    };
    SyncApi.prototype.uploadCompanyLogo = function (local_path, mimetype, on_progress) {
        return this.uploadInternal(local_path, mimetype, "" + this._company_logo, on_progress);
    };
    SyncApi.prototype.upload = function (local_path, key, mimetype, on_progress) {
        key = key.replace(/[^0-9a-zA-Z\-\_]/gi, '');
        return this.uploadInternal(local_path, mimetype, this._upload + "?key=" + key, on_progress);
    };
    SyncApi.prototype.uploadFile = function (local_path, key, mimetype, on_progress) {
        key = key.replace(/[^0-9a-zA-Z\-\_]/gi, '');
        return this.uploadInternal(local_path, mimetype, this._upload + "?key=" + key, on_progress);
    };
    SyncApi.prototype.conversationUploadPut = function (conversation, local_path, mimetype, on_progress) {
        var uuid = conversation.uuid.replace(/[^0-9a-zA-Z\-\_]/gi, '');
        return this.uploadInternal(local_path, mimetype, this._upload_conversation_put.replace("{uuid}", uuid), on_progress);
    };
    SyncApi.prototype.conversationUploadGet = function (conversation, key) {
        var uuid = conversation.uuid.replace(/[^0-9a-zA-Z\-\_]/gi, '');
        key = key.replace(/[^0-9a-zA-Z\-\_]/gi, '');
        return this._upload_conversation_get.replace("{uuid}", uuid).replace("{key}", key) + "?token=" + this._persistence_token;
    };
    SyncApi.prototype.uploadInternal = function (local_path, mimetype, url, on_progress) {
        var _this = this;
        var options = {
            url: url,
            path: local_path,
            method: 'PUT',
            type: 'raw',
            maxRetries: 2,
            headers: {
                "content-type": mimetype,
                "token": this._persistence_token
            },
            // Below are options only supported on Android
            notification: {
                enabled: true,
                autoClear: true,
                //onCompleteTitle: null,
                //onCompleteMessage: null,
                //onErrorTitle: null,
                //onErrorMessage: null,
                onProgressTitle: "uploading",
                onProgressMessage: "in progress",
            },
            useUtf8Charset: true
        };
        if (!this.Upload)
            return Promise.reject("Upload not known, please install react-native-background-upload");
        return this.Upload.startUpload(options).then(function (uploadId) {
            return new Promise(function (resolve, reject) {
                _this.Upload.addListener('progress', uploadId, function (data) {
                    on_progress && on_progress(data.progress);
                    console.log("Progress: " + data.progress + "%");
                });
                _this.Upload.addListener('error', uploadId, function (data) {
                    reject(data);
                });
                _this.Upload.addListener('completed', uploadId, function (data) {
                    resolve(data);
                });
            });
        });
    };
    return SyncApi;
}());
export { SyncApi };
var Api = /** @class */ (function () {
    function Api(env, Upload, downloadFile, downloadStop) {
        var _this = this;
        this.light = function () { return _this._light; };
        this.profile = function () { return _get(_this._env + PROFILE, undefined, _this._persistence_token); };
        this.iaps = function () { return _get(_this._env + GET_USER_IAP, undefined, _this._persistence_token); };
        this.gemsTo1Giga = function () { return _get(_this._env + GET_1GIGA, undefined, _this._persistence_token); };
        this.gemsTo10Giga = function () { return _get(_this._env + GET_10GIGA, undefined, _this._persistence_token); };
        this.registry = function () { return _get(_this._env + GET_REGISTRY, undefined, _this._persistence_token); };
        this._env = env;
        this._persistence_token = "";
        this._light = new LightApi(env);
        this.sync = new SyncApi(env, Upload, downloadFile, downloadStop);
    }
    Api.prototype.setAuthToken = function (persistence_token) {
        this._persistence_token = persistence_token;
        this.sync.setAuthToken(persistence_token);
    };
    Api.prototype.report = function () {
        return _get(this._env + REPORT, undefined, this._persistence_token);
    };
    Api.prototype.report_thunder = function (project) {
        return _get(this._env + REPORT_THUNDER, {
            project: project
        }, this._persistence_token);
    };
    Api.prototype.report_weather = function (project) {
        return _get(this._env + REPORT_WEATHER, {
            project: project
        }, this._persistence_token);
    };
    Api.prototype.report_routair_data = function (routair, left, right) {
        return _get("" + this._env + GET_ROUTAIR_DATA + routair, { left: left.toDate().getTime(), right: right.toDate().getTime() }, this._persistence_token);
    };
    Api.prototype.report_weather_month = function (project, left, right) {
        return _get(this._env + V3_ROOT + ("/data/project/" + project + "/history"), { left: left.toDate().getTime(), right: right.toDate().getTime() }, this._persistence_token);
    };
    Api.prototype.report_weather_day = function (project, date) {
        return _get(this._env + V3_ROOT + ("/data/project/" + project + "/history"), { date: date }, this._persistence_token);
    };
    Api.prototype.report_alerts_month = function (project, left, right) {
        return _get(this._env + V3_ROOT + ("/data/project/" + project + "/alerts"), { left: left.toDate().getTime(), right: right.toDate().getTime() }, this._persistence_token);
    };
    Api.prototype.report_score = function (left, right, project) {
        return _get(this._env + V3_ROOT + ("/data/projects/" + project + "/score"), { left: left.toDate().getTime(), right: right.toDate().getTime() }, this._persistence_token);
    };
    Api.prototype.report_alerts_day_all = function (left, right, utcOffset) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _get(this._env + V3_ROOT + "/data/projects/light/alerts", { left: left.toDate().getTime(), right: right.toDate().getTime(), utcOffset: utcOffset }, this._persistence_token)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result.map(function (row) { return (__assign(__assign({}, row), { date: moment(row.date) })); })];
                }
            });
        });
    };
    Api.prototype.report_alerts_day_project = function (project, left, right, utcOffset) {
        return __awaiter(this, void 0, void 0, function () {
            var tmp, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (left.isAfter(right)) {
                            tmp = left;
                            left = right;
                            right = tmp;
                        }
                        return [4 /*yield*/, _get(this._env + V3_ROOT + ("/data/project/light/" + project + "/alerts"), { left: left.toDate().getTime(), right: right.toDate().getTime(), utcOffset: utcOffset }, this._persistence_token)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result.map(function (row) { return (__assign(__assign({}, row), { date: moment(row.date) })); })];
                }
            });
        });
    };
    Api.prototype.report_device_month = function (project, device, year, month) {
        return _get(this._env + V3_ROOT + ("/data/project/" + project + "/device/" + device + "/history/" + year + "/" + month), undefined, this._persistence_token);
    };
    Api.prototype.register_devices = function (register) {
        return _post(this._env + REGISTER_DEVICE_PROJECT, undefined, register, this._persistence_token);
    };
    Api.prototype.project_personnalisations_list = function (project) {
        return _get(this._env + V3_ROOT + ("/personnalise/project/" + project + "/list"), {}, this._persistence_token);
    };
    Api.prototype.project_personnalisations_status = function (project) {
        return _get(this._env + V3_ROOT + ("/personnalise/project/" + project + "/status"), {}, this._persistence_token);
    };
    Api.prototype.project_personnalisations_enable = function (project) {
        return _put(this._env + V3_ROOT + ("/personnalise/project/" + project + "/enable"), undefined, {}, this._persistence_token);
    };
    Api.prototype.report_device = function (id) {
        return _get(this._env + DEVICE + id + "/report.json", undefined, this._persistence_token);
    };
    Api.prototype.logs = function (id) {
        return _get(this._env + DEVICE + id + "/logs.json", undefined, this._persistence_token);
    };
    Api.prototype.weather = function (position) {
        return _post(this._env + WEATHER, undefined, __assign({}, position));
    };
    Api.prototype.login = function (login, password) {
        return _post(this._env + LOGIN, undefined, { login: login, password: password });
    };
    Api.prototype.register = function (login, email, password) {
        return _post(this._env + REGISTER, undefined, { login: login, email: email, password: password });
    };
    Api.prototype.updateToken = function (push_token, platform) {
        return _post(this._env + PUSH, undefined, {
            push_token: push_token,
            platform: platform
        }, this._persistence_token);
    };
    Api.prototype.updateProfile = function (json) {
        return _post(this._env + PROFILE, undefined, json, this._persistence_token);
    };
    Api.prototype.devices = function () {
        return _get(this._env + DEVICES, undefined, this._persistence_token);
    };
    Api.prototype.env = function () {
        return this._env;
    };
    return Api;
}());
export default Api;
//# sourceMappingURL=Api.js.map