export interface Headers {
    [key: string]: string;
}
export interface DownloadResult {
    jobId: number;
    statusCode: number;
    bytesWritten: number;
}
export interface DownloadBeginCallbackResult {
    jobId: number;
    statusCode: number;
    contentLength: number;
    headers: Headers;
}
export interface DownloadProgressCallbackResult {
    jobId: number;
    contentLength: number;
    bytesWritten: number;
}
export interface DownloadFileOptions {
    fromUrl: string;
    toFile: string;
    headers?: Headers;
    background?: boolean;
    discretionary?: boolean;
    cacheable?: boolean;
    progressInterval?: number;
    progressDivider?: number;
    begin?: (res: DownloadBeginCallbackResult) => void;
    progress?: (res: DownloadProgressCallbackResult) => void;
    resumable?: () => void;
    connectionTimeout?: number;
    readTimeout?: number;
    backgroundTimeout?: number;
}
export interface DownloadFileResult {
    jobId: number;
    promise: Promise<DownloadResult>;
}
