export interface Position {
    latitude: number;
    longitude: number;
}
export interface Coord {
    lon: number;
    lat: number;
}
export interface WeatherCondition {
    id: number;
    main: string;
    description: string;
    icon: string;
}
export interface MainInformation {
    temp: number;
    pressure: number;
    humidity: number;
    temp_min: number;
    temp_max: number;
}
export interface Wind {
    speed: number;
    deg: number;
}
export interface Clouds {
    all: number;
}
export interface Sys {
    type: number;
    id: number;
    message: number;
    country: number;
    sunrise: number;
    sunset: number;
}
export interface WeatherData {
    coord: Coord;
    weather: WeatherCondition[];
    base: string;
    main: MainInformation;
    wind: Wind;
    clouds: Clouds;
    dt: number;
    sys: Sys;
    timezone: number;
    id: number;
    name: string;
    cod: number;
}
